#!/usr/bin/python
# -*- encoding: utf-8 -*-
###########################################################################
#    Copyright (C) Industrias Diana, C.A. (www.industriasdiana.gob.ve)
#    All Rights Reserved
###############Credits######################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################
#
# Facturar pago de guarderias
#
##############################################################################

from osv import fields, osv
from tools.translate import _

class hr_payslip(osv.osv):
    
    _inherit = 'hr.payslip'
    _description = 'Pay Slip'


    def new_invoice(self, cr, uid, payslip, partner, lines, journal_id, type='in_invoice', context=None):
        """
        Se hereda funcion para agregar la partida presupuestaria y la accion especifica
        a las lineas de la factura en la creacion de las facturas de guarderia.
        """
        result = super(hr_payslip, self).new_invoice(cr, uid, payslip, partner, lines, journal_id, type=type, context=context)
        
        invoice_obj = self.pool.get('account.invoice')
        invoice_line_obj = self.pool.get('account.invoice.line')
        obj_hr_acct = self.pool.get('hr.account')
        
        accion_esp = payslip.employee_id.accion_especifica_id
        department = payslip.employee_id.department_id
        payroll = payslip.employee_id.hr_payroll_id

        concept = payslip.line_ids[0].salary_rule_id.concept_id if payslip.line_ids[0].salary_rule_id else payslip.line_ids[0].attribute_id.concept_id
        account_id = obj_hr_acct.search(cr, uid, [('concept_id','=',concept.id),
                            ('analytic_account_id','=',department.departament_analytic_account_id.id),
                            ('payroll_id','=',payroll.id)])
        if not account_id:
            raise osv.except_osv(_('Error!'), _('No existe una configuración contable para el concepto\
                %s, cuenta analítica %s y nómina %s. Para verificar ir a\
                Talento Humano -> Configuración -> Contabilidad nómina.')
                % (concept.name, department.departament_analytic_account_id.complete_name, payroll.name))
        
        account = obj_hr_acct.browse(cr, uid, account_id)
            
        if isinstance(account, list):
            account = account[0]
        
        partida = account.partida_presupuesto and account.partida_presupuesto.id or False
        accion_esp = accion_esp.id or False
        
        invoice_id = result
        if isinstance(invoice_id, (int,long)):
            invoice_id = [invoice_id]
            
        for inv in invoice_obj.browse(cr, uid, invoice_id, context=context):
            for inv_lin in inv.invoice_line:
                invoice_line_obj.write(cr, uid, inv_lin.id, {'accion_especifica_id': accion_esp, 'partida_presupuesto': partida}, context=context)
        
        return result

hr_payslip()
