#!/usr/bin/python
# -*- encoding: utf-8 -*-
##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2010 Tiny SPRL (<http://tiny.be>).
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as
#    published by the Free Software Foundation, either version 3 of the
#    License, or (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

class anticipos_parser(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(anticipos_parser, self).__init__(cr, uid, name, context=context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'totalizar_anticipo': self.totalizar_anticipo,
            'totalizar_monto': self.totalizar_monto,
            'get_anticipo': self.get_anticipo,
            #~ 'get_final_date': self.get_final_date,
            #~ 'get_fecha': self.get_fecha,
        })
        self.total_anticipo = 0.00
        self.total_monto = 0.00
    
    def totalizar_monto(self, m):
        for l in m:
            self.total_monto += l.amount
        return self.total_monto
    
    def totalizar_anticipo(self, o):
        for l in o.move_line_ids:
            if o.type == 'cobrar':
                self.total_anticipo += l.credit
            else:
                self.total_anticipo += l.debit
        return self.total_anticipo
    
    def get_anticipo(self, type, mov):
        if type == 'cobrar':
            monto = mov.credit
        else:
            monto = mov.debit
        return monto
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
       
report_sxw.report_sxw('report.account.advances.report',
    'account.advances',
    'sisb_anticipos/report/account_advances_report.rml',
    parser=anticipos_parser)
