#-*- coding:utf-8 -*-
##############################################################################
#
#    SISB, Sistema Integral Simón Bolivar
#    Copyright (C) 2012-2013 Industrias Diana, C.A. All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

from osv import fields, osv
from tools.translate import _
from datetime import datetime
from datetime import timedelta

class cur_estudios(osv.osv):
    _name = 'cur.estudios'
    _description = 'Estudios'
    _columns = {
        'name': fields.char('Nombre de estudio', size=256, required=True),
        'type_study': fields.selection([
                ('', ''),
                ('curso', 'Curso'),
                ('taller', 'Taller'),
                ('diplomado', 'Diplomado'),
                ('doctorado', 'Doctorado'),
                ('maestria', 'Maestria'),
            ], 'Tipo de Estudio', select=True, required=True),
        'descripcion': fields.text('Descripcion'),
    }
    _sql_constraints = [('unique_name','unique(name)', _('Ya existe un estudio con el mismo nombre'))]
    _order = "name asc"
cur_estudios()

class cur_instituciones(osv.osv):
    _name = 'cur.instituciones'
    _description = 'Instituciones'
    _columns = {
        'name': fields.char('Nombre', size=256, required=True),
        'descripcion': fields.text('Descripcion'),
    }
    _sql_constraints = [('unique_name','unique(name)', _('Ya existe una institucion con el mismo nombre'))]
    _order = "name asc"
cur_instituciones()


class cur_estudios_realizados(osv.osv):
    _name = 'cur.estudios.realizados'
    _description = 'Estudios realizados'
    _columns = {
        'employee_id': fields.many2one('hr.employee', 'Trabajador', required=True),
        'study_id': fields.many2one('cur.estudios', 'Estudio', required=True),
        'partner_id': fields.many2one('res.partner', 'Empresa', required=False),
        'institucion_id': fields.many2one('cur.instituciones', 'Institucion', required=False),
        'date': fields.date('Fecha'),
        'duration': fields.char('Duracion', size=256, required=False),
        'promoted': fields.boolean('Por la empresa'),
        'type': fields.selection([
                ('horas', 'Horas'),
                ('dias', 'Dias'),
                ('semanas', 'Semanas'),
                ('meses', 'Meses'),
                ('trimestres', 'Trimestres'),
                ('semestres', 'Semestres'),
                ('anos', 'Años'),
            ], 'Tipo de Estudio', select=True, required=False),
        'cost': fields.float('Costo'),
    }
    _rec_name = "employee_id"
cur_estudios_realizados()


class cur_employee_herencia(osv.osv):
    _name = "hr.employee"
    _inherit = "hr.employee"
    _columns = {
        'studies_ids': fields.one2many('cur.estudios.realizados', 'employee_id', 'Estudios'),
    }
cur_employee_herencia()

