#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import datetime
import time 
import logging


class hr_process(osv.osv):

    _inherit = "hr.process"
    
    def cambiar_estado_horas_extras(self, cr, uid, ids, estado, context=None):
        if context is None:
           context = {}
        horas_extras_obj = self.pool.get('horas.extras.planificacion')
        horas_extras_lines_obj = self.pool.get('horas.extras.planificacion.lineas')
        hr_variable_concept_obj = self.pool.get('hr.variable.concepts')
        hr_variable_concept_line_obj = self.pool.get('hr.variable.concept.line')
        procesos = self.pool.get('hr.process').browse(cr, uid, ids, context=context)
        horas_extras_list = []
        historico_list = []
        for proceso in procesos:
            if proceso.type == 'nomina':
                variable_concept_ids = hr_variable_concept_obj.search(cr, uid, [('hr_process_id','=',proceso.id),
                                                                         ('tipo_de_proceso','=','sobretiempo')],
                                                                         context=None)
                historico_ids = horas_extras_obj.search(cr, uid, [('variable_concept_id','in', variable_concept_ids)])
                historico_brw = horas_extras_obj.browse(cr, uid, historico_ids)
                for h in  historico_brw:
                    horas_extras_list.append(h.id) 
        
        horas_extras_brw = horas_extras_obj.browse(cr, uid, horas_extras_list)
        lineas_horas_extras_update = [l.id for i in horas_extras_brw for l in i.planificacion_lineas_ids if l.state != 'cancel']
        if horas_extras_list:
            horas_extras_obj.write(cr, uid, horas_extras_list, {'state':estado})          
            horas_extras_obj.write_state_lines(cr ,uid, horas_extras_list, estado, lines=lineas_horas_extras_update)                       
        return True 
    
    def aprobar_proceso(self, cr, uid, ids, context=None):
        """
        Se incluye funcion que pasa de estado 'approved' (aprobado) a estado 'done' (terminado) los reposos
        que hayan sido pagados en su totalidad en la aprobacion de este proceso de nomina.
        """
        self.cambiar_estado_horas_extras(cr, uid, ids, 'done', context)
        #~ return True 
        return super(hr_process,self).aprobar_proceso(cr, uid, ids, context)
        
    def devolver_proceso(self, cr, uid, ids, context=None):
        """
        Se incluye funcion que pasa de estado 'done' (terminado) a estado 'approved' (aprobado) los reposos
        que hayan sido pagados en su totalidad en la aprobacion de este proceso de nomina.
        """
        self.cambiar_estado_horas_extras(cr, uid, ids, 'approved', context)
        #~ return True 
        return super(hr_process,self).devolver_proceso(cr, uid, ids, context)
        
    def cancel(self, cr, uid, ids, context=None):
        """
        Se sobreescribe el metodo para eliminar el historico de los reposos
        que se hayan cargado en los conceptos variables del proceso de nomina.
        """
        self.cambiar_estado_horas_extras(cr, uid, ids, 'draft', context)
        #~ return True 
        return super(hr_process,self).cancel(cr, uid, ids, context)

hr_process()
