from report import report_sxw
import datetime 

class horas_extras_planificacion(report_sxw.rml_parse):
    _name =  'horas.extras.planificacion'
    
    def __init__(self, cr, uid, name, context):
        super(horas_extras_planificacion, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'str':str,
            'get_empresa':self.get_empresa,
            'formato_fecha_hora':self.formato_fecha_hora,
            'get_grupo_id':self.get_grupo_id,
        })
        
        self.context = context

    def get_grupo_id(self, group_name):
        """Devuelve el id del grupo 'group_name'. Devuelve False en caso de no existir """
        model_data_obj = self.pool.get('ir.model.data')
        grupo_search =  model_data_obj.search(self.cr, 1, [('name','=',group_name),('model','=','res.groups')])
        grupo = model_data_obj.read(self.cr, 1, grupo_search, ['res_id'])[0]['res_id']
        grupo_usuario = self._get_grupos_usuario(self.uid)
        if grupo in grupo_usuario:
            return True
        return False
    
    def _get_grupos_usuario(self, uid):
        return [group.id for group in self.pool.get('res.users').browse(self.cr, 1, uid).groups_id]
    
    def formato_fecha_hora(self, dato):
		d = datetime.datetime.strptime(dato, "%Y-%m-%d %H:%M:%S")
		return d.strftime("%d/%m/%Y %H:%M:%S")
		
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
        
        

report_sxw.report_sxw(
    'report.horas.extras.planificacion',
    'horas.extras.planificacion',
    'sisb_horas_extras/report/horas_extras_planificacion.rml',
    parser=horas_extras_planificacion, header=False)

