#!/usr/bin/env python

import datetime

class sobretiempo_for_turnos():
	
    def __init__(self, turno_actual, turno_post, hora_entrada, hora_salida, dias):
        convert = self.convert_datetime 
        self.turno_entrada_act = convert(turno_actual[0],tipo='time')
        self.turno_salida_act = convert(turno_actual[1],tipo='time')
        self.turno_entrada_post = convert(turno_post[0],tipo='time')
        self.turno_salida_post = convert(turno_post[1],tipo='time')
        self.hora_entrada = convert(hora_entrada,tipo='time')
        self.hora_salida = convert(hora_salida,tipo='time')
        self.dias = dias
    
    def convert_datetime(self, value_date, tipo=None, format_inp=None):
        d = {}
        format_inp = {'time':"%H:%M:%S", 
                      'date':"%Y-%m-%d",
                       'object':"%Y-%m-%d %H:%M:%S",
                       None:"%Y-%m-%d %H:%M:%S"}
        if tipo in format_inp:
           format_inp = format_inp[tipo]
        else:
            format_inp = "%Y-%m-%d %H:%M:%S"
           
        value_date = datetime.datetime.strptime(value_date, format_inp)
        d = {'date':value_date.strftime("%Y-%m-%d"),
            'time':value_date.strftime("%H:%M:%S"), 
            'object': value_date}
        if  tipo:
            return d[tipo] 
        return d
    
    def subtract_hours(self,  hr, ha):
        criterio = 3600
        r1 =  datetime.datetime.strptime(hr, '%H:%M:%S')
        r2 =  datetime.datetime.strptime(ha, '%H:%M:%S')
        dif = r2 - r1 
        ab = abs(dif)
        time =  float(ab.seconds / float(criterio))
        time = round(time, 2)
        return time 
    
    def laborable(self, start, end):
        param = '00:00:00'
        if start == param and end == param:
           return False
        return True
    
    def validar_turno(self, turno):
        tipo = None
        if turno[1] > turno[0]:
           tipo = 'diurno'
        else:
            tipo = 'nocturno'
        return tipo
    
    def sobretiempo(self, start, end, entrada, dia=None):
        diff = self.subtract_hours
        tipo = {'diurno':0.00,'nocturno':0.00}
        if not dia:
           dia = self.dias
        diurno_start = '05:00:00'
        diurno_end = '18:59:59'
        nocturno_start = '19:00:00'
        nocturno_end = '23:59:59'
        inicio = '00:00:00'
        if dia==1:
           if start >= nocturno_start and start <= nocturno_end and end >= '00:00:00' and end <= diurno_start: #sobretiempo noche-noche de un dia a otro
              tipo['nocturno'] += diff(nocturno_end, start)
              tipo['nocturno'] += diff(inicio, end)
           
           elif start >= nocturno_start and start <= nocturno_end and end >= diurno_start and (end <= entrada or end >= entrada):#sobretiempo noche-dia de un dia a otro
              tipo['nocturno'] += diff(nocturno_end, start)
              tipo['nocturno'] += diff(inicio, diurno_start)
              if entrada > diurno_start and entrada <= diurno_end and  end >= entrada:
                 tipo['diurno'] += diff(diurno_start, entrada)
              
              elif end >= nocturno_start and end <= nocturno_end and  end >= entrada:
                  tipo['diurno'] += diff(diurno_start, diurno_end)
                  tipo['nocturno'] += diff(nocturno_start, end)
           
           
           elif start >= diurno_start and start <= diurno_end and end >= diurno_start and (end <= entrada or end >= entrada):#sobretiempo dia-noche-dia  de un dia a otro pasando su hora de entrada
              tipo['diurno'] += diff(diurno_end, start)
              tipo['nocturno'] += diff(nocturno_end, nocturno_start)
              tipo['nocturno'] += diff(diurno_start, inicio)
              if entrada > diurno_start and entrada <= diurno_end and  end >= entrada:
                 tipo['diurno'] += diff(diurno_start, entrada)
              
              elif end >= nocturno_start and end <= nocturno_end and  end >= entrada:
                   tipo['diurno'] += diff(diurno_start, diurno_end)
                   tipo['nocturno'] += diff(nocturno_start, end)
              
              elif end >= diurno_start and end <= diurno_end and  end >= entrada:
                   tipo['diurno'] += diff(diurno_start, end)
           
           
           elif start >= diurno_start and start <= diurno_end and end <= diurno_start:#sobretiempo dia-noche  de un dia a otro 
              tipo['diurno'] += diff(diurno_end, start)
              tipo['nocturno'] += diff(nocturno_end, nocturno_start)
              tipo['nocturno'] += diff('00:00:00', end)
        else:
             if start >= diurno_start and start <= diurno_end and end >= nocturno_start and end <= nocturno_end:
                tipo['diurno'] += diff(diurno_end, start) 
                tipo['nocturno'] += diff(nocturno_start, end)
             elif start >= diurno_start and start <= diurno_end and end >= diurno_start and end <= diurno_end:
                  tipo['diurno'] += diff(start,end) 
             elif start >= nocturno_start and start <= nocturno_end and end >= nocturno_start and end <= nocturno_end:
                tipo['nocturno'] += diff(start,end) 
        return tipo
        
    def intervalo_1(self, start, end, turno_1, turno_2):
        en_turno = {'hora_desde':False, 'hora_hasta':False}
        dia = self.dias
        if dia == 0:
		   if  start >= turno_1[0] and  start <= turno_1[1]:
			   en_turno['hora_desde'] = True
		   if  end >= turno_1[0] and  end <= turno_1[1]:
			   en_turno['hora_hasta'] = True
        elif dia == 1:
             if turno_1[1] > turno_1[0]:
                 if start >= turno_1[0] and  start <= turno_1[1]:
                    en_turno['hora_desde'] = True
             else:
                   if start >= turno_1[1] and  start <= turno_1[0]:
                    en_turno['hora_desde'] = True  
                    
             if turno_2[1] > turno_2[0]:    
                 if end >= turno_2[0] and  end <= turno_2[1]:
                    en_turno['hora_hasta'] = True 
             else:    
                 if end >= turno_2[1] and  end <= turno_2[0]:
                    en_turno['hora_hasta'] = True 
            
        return en_turno
    
    
    def calcular(self):
        diff = self.subtract_hours
        tipo = {'diurno':0.00,'nocturno':0.00}
        sobretiempo = self.sobretiempo
        laborable_act = self.laborable(self.turno_entrada_act, self.turno_salida_act)
        laborable_post= self.laborable(self.turno_entrada_post, self.turno_salida_post)
        tipo_turno = self.validar_turno([self.turno_entrada_post, self.turno_salida_act])
        hora_entrada = self.hora_entrada
        hora_salida = self.hora_salida 
        dia = self.dias
        turno_actual = [self.turno_entrada_act, self.turno_salida_act]
        turno_posterior = [self.turno_entrada_post, self.turno_salida_post]
        validar_intervalos = self.intervalo_1(hora_entrada, hora_salida, turno_actual, turno_posterior)  
        en_intervalo_desde = validar_intervalos['hora_desde']
        en_intervalo_hasta = validar_intervalos['hora_hasta']
        intervalos = (en_intervalo_desde and en_intervalo_hasta)
        if laborable_act and laborable_post:
            if not intervalos:
                if en_intervalo_desde and not en_intervalo_hasta:
                   tipo = sobretiempo(self.turno_salida_act, hora_salida, self.turno_entrada_post) 
                elif not en_intervalo_desde and en_intervalo_hasta:
                   tipo = sobretiempo(hora_entrada, self.turno_entrada_post, self.turno_entrada_post)
                else:
                    tipo = sobretiempo(hora_entrada, hora_salida, self.turno_entrada_post)
                    
            else:
                tipo = sobretiempo(hora_entrada, hora_salida, self.turno_entrada_post)
        else:
            tipo = sobretiempo(hora_entrada, hora_salida, self.turno_entrada_post)
        return tipo
    
        
