#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import datetime
import time 


class horas_extras_excepcion_wizard(osv.osv_memory):
    _name = 'horas.extras.execepcion.wizard'
    _description = 'excepcion de horas extras lineas'
    _columns = {
      'shift_id': fields.many2one('hr.shift', 'Ingrese el Turno', required=True),
    }
    
    def modify(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids[0])
        turno = brw.shift_id
        idsw = context['active_id']
        horas_extras_lines_obj = self.pool.get('horas.extras.planificacion.lineas')
        horas_extras_obj = self.pool.get('horas.extras.wizard.concept.variable')
        horas_extras_execcion_obj = self.pool.get('horas.extras.planificacion.lineas.excepciones')
        horas_extras_calc_obj = self.pool.get('horas.extras.planificacion.calculos')
        line = horas_extras_lines_obj.browse(cr, uid, idsw)
        fecha_desde = "%s %s"%(line.fecha_desde, line.hora_desde)
        fecha_hasta = "%s %s"%(line.fecha_hasta, line.hora_hasta)
        value = horas_extras_obj.calcular_sobretiempo(cr, uid, ids, fecha_desde, fecha_hasta, line.empleado_id.id, line.id, shift_id=turno)
        for v in value:
            if value[v] > 0.00:
                dict_exception = {
                'horas_extras_planificacion_lineas_id':line.id,
                'value':value[v],
                'concept_id':v,}
                horas_extras_execcion_obj.create(cr, uid, dict_exception)
                param = [('horas_extras_planificacion_id','=',line.horas_extras_planificacion_id.id),
                ('concept_id','=',v), ('trabajador_id', '=',  line.empleado_id.id)]
                calc_ids = horas_extras_calc_obj.search(cr, uid, param)
                if calc_ids:
                    calc_brw= horas_extras_calc_obj.browse(cr, uid, calc_ids)[0]
                    value = calc_brw.value + value[v]
                    horas_extras_calc_obj.write(cr, uid, calc_ids, {'value':value} )
                else:
                    dict_exception_calc = {
                    'horas_extras_planificacion_id':line.horas_extras_planificacion_id.id,
                    'value':value[v],
                    'concept_id':v,
                    'trabajador_id':line.empleado_id.id
                    }
                    horas_extras_calc_obj.create(cr, uid, dict_exception_calc)

        horas_extras_lines_obj.write(cr, uid, idsw, {'state':'processing'})    
                  
         
        return {
            'type': 'ir.actions.act_window_close',
            'active_id': ids
            }
             
    def cancel(self, cr, uid, ids, context=None):
        
        idsw = [context['active_id']]
        horas_extras_lines_obj = self.pool.get('horas.extras.planificacion.lineas')
        horas_extras_lines_obj.write(cr, uid, idsw, {'state':'cancel'})
        
        return {
            'type': 'ir.actions.act_window_close',
            'active_id': ids
         }
    
    

            
        
        
        
        
        
        
        
             

horas_extras_excepcion_wizard()
