#-*- coding:utf-8 -*-

import time
from datetime import date
from datetime import datetime
from datetime import timedelta
from dateutil import relativedelta

import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import decimal_precision as dp
import math
from tools.safe_eval import safe_eval as eval
import logging
import unicodedata


def elimina_tildes(s):
    """
    Funcion para eliminar las tildes de algun texto utilizando el modulo unicodedata.
    """
    return ''.join((c for c in unicodedata.normalize('NFD', s) if unicodedata.category(c) != 'Mn'))
    
class hr_employee(osv.osv):
    _inherit = 'hr.employee'

    def state_active_to_holidays(self, cr, uid, ids=None, context=None):
        """ Runs through scheduler.
        Metodo usado para verificar los trabajadores que deben pasar a 
        estado vacaciones
        """
        if context is None:
            context = {}
        
        today = datetime.now().strftime('%Y-%m-%d')
        
        """ 
        Trabajadores que deben pasar de estado activo a vacaciones:
        Condiciones:
            1- Se deben pasar a vacaciones los trabajadores en estado activo 
            que tienen registro de disfrute de vacaciones con 'fecha inicio'
            menor o igual a la fecha del dia. 
        """
        date = (datetime.strptime(today,'%Y-%m-%d')).strftime('%Y-%m-%d')
        employees_hol_ids = self.pool.get('hr.holidays').search(cr, uid, [('date_from','<=',date),
          ('date_to','>=',date),('employee_id.state','=','activo'),('type','=','remove'),
          ('type_holidays_status','=','Vacaciones Legales'),('state','=','validate')])
        
        employees_hol_brw = self.pool.get('hr.holidays').browse(cr, uid, employees_hol_ids)
        emp_ids = [x.employee_id.id for x in employees_hol_brw]
        if emp_ids:
            cr.execute('''UPDATE hr_employee set state = 'vacaciones' where id in %s''',
              (tuple(emp_ids),))
        
        """ 
        Trabajadores que deben pasar de estado vacaciones a activo.
        Condiciones:
            1- Se deben pasar a activos los trabajadores en estado de vacaciones 
            que tienen registro de disfrute de vacaciones con 'fecha inicio'
            menor a la fecha del dia.
        """
        reg_hol_validos_ids = self.pool.get('hr.holidays').search(cr, uid, [('date_from','<',date),
          ('employee_id.state','=','vacaciones'),('type','=','remove'),
          ('type_holidays_status','=','Vacaciones Legales'),('state','=','validate')], 
          order='employee_id, date_from desc')
        
        employees_hol_brw = self.pool.get('hr.holidays').browse(cr, uid, reg_hol_validos_ids)
        dict_ = {}
        
        """
            Pueden haber trabajadores con varios registros que cumplan con la 
            condicion 1, pero solo se debe tomar en cuenta el ultimo registro de
            vacaciones (el que tenga mayor 'fecha inicio') y luego verificar si ese 
            registro tiene 'fecha final' menor a la fecha del dia. Luego se
            pasan a activos solo los trabajadores que cumpan con tal condicion.
        """
        for hol in employees_hol_brw:
            if not hol.employee_id in dict_:
                dict_[hol.employee_id] = hol
            elif hol.date_from > dict_[hol.employee_id].date_from:
                dict_[hol.employee_id] = hol
        
        emp_ids = []
        if dict_:
            for hol in dict_:
                emp_ids = emp_ids + [x.employee_id.id for x in [dict_[hol]] if x.date_to < date]
            if emp_ids:
                cr.execute('''UPDATE hr_employee set state = 'activo' where id in %s''',
                  (tuple(emp_ids),))
        return True
                
hr_employee()
