#!/usr/bin/python
# -*- encoding: utf-8 -*-

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime

class family_report(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(family_report, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'nombre': self.nombre,
            'codigo': self.codigo,
            'cedula': self.cedula,
            'sede': self.sede,
            'fam': self.fam,
            'fam2': self.fam2,
            'fam3': self.fam3,
            'prueba': self.prueba,
            
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    def prueba(self, e, l):
        return e[l]

    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
       
       
    def nombre(self, id):
        
        obj_employee = self.pool.get('hr.employee')
        
        if id:
            for i in id:
                datos = obj_employee.browse(self.cr, self.uid, i)
        return datos.name
    
    def codigo(self, id):
        obj_employee = self.pool.get('hr.employee')
        
        if id:
            for i in id:
                datos = obj_employee.browse(self.cr, self.uid, i)
        return datos.cod_number
    
    def cedula(self, id):
        obj_employee = self.pool.get('hr.employee')
        
        if id:
            for i in id:
                datos = obj_employee.browse(self.cr, self.uid, i)
        return datos.identification_id
    
    def sede(self, id):
        obj_employee = self.pool.get('hr.employee')
        
        if id:
            for i in id:
                datos = obj_employee.browse(self.cr, self.uid, i)
        return datos.hr_sede_id.name
        
    def fam(self, lista):
        can = len(lista)
        return can
        
    def fam2(self, lista):
        cant = 0
        for i in lista:
            for x in i.values():
                for c in x:
                    cant = cant + 1 
        return cant
        
        
    def fam3(self, lista):
        cant = 0

        for i in lista:
            for f in i.values():
                for o in f:
                    for h in o.values():
                        for c in h:
                            cant = cant + 1 
        return cant   


report_sxw.report_sxw('report.sisb.familiares',
    'family.report.wizard',
    'sisb_nomina/report/family_report.rml',
    parser=family_report)
