#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime


class hr_listado_conceptos(osv.osv_memory):
    _name = 'hr.listado.conceptos'
    _description = 'Creacion listado de conceptos'

    _columns = {
        'month_id': fields.many2one('hr.month', 'Mes', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nomina'),
        'sede_ids':fields.many2many('hr.sede', 'hr_report_wizard_concept_rel', 
          'report_id', 'sede_id', 'Sedes'),
        'concept_id': fields.many2one('hr.concept', "Concepto"),
    }
    
    def hr_listado_conceptos(self, cr, uid, ids, context=None):
        paid_brw = self.browse(cr, uid, ids)[0]
        name_concepts = {'name_concepts':{}}
        parameter_obj = self.pool.get('hr.parameters')
        concept_params = []
        concepto = paid_brw.concept_id.id
        if paid_brw.sede_ids:
            sedes = [x.id for x in paid_brw.sede_ids]
        else: 
            False
        concept_name = paid_brw.concept_id.name 
        # Defino los parametros a buscar
      
        conceptos_con_aporte_id = parameter_obj.search(cr, uid, [
          ('type', '=', 'concepto_aportes_empresa')])
        if conceptos_con_aporte_id:
           conceptos_con_aporte_brw = parameter_obj.browse(cr, uid, conceptos_con_aporte_id)[0]
           concept_params = conceptos_con_aporte_brw.concepto_aportes_empresa_ids
           concept_params = [i.id for i in concept_params]
        
        if concepto in concept_params:   
            
            faov_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_faov'), 
              ('concept_faov_id', '=', concepto)])
            jubilacion_id = parameter_obj.search(cr, uid, [
              ('type', '=', 'concepto_jubilacion'), 
              ('concept_jubilacion_id', '=', concepto)])
            sso_id = parameter_obj.search(cr, uid, [('type', '=',  'concepto_sso'), 
              ('concept_sso_id', '=', concepto)])
            caja_ahorro_id = parameter_obj.search(cr, uid, [
              ('type', '=',  'concepto_caja_ahorro'), 
              ('concepto_caja_ahorro_id', '=', concepto)])
            regimen_id = parameter_obj.search(cr, uid, [
              ('type', '=', 'concepto_prestacional_emp'),
              ('concepto_prestacional_emp_id', '=', concepto)])
            busqueda = None 
            
            if  faov_id:
                faov_brw = parameter_obj.browse(cr, uid, faov_id)
                if not faov_brw[0].concept_faov_id:
                    raise osv.except_osv(_('ERROR!'), _('No hay un concepto %s \
                      asociado para el parametro %s' %(concept_name, faov_brw[0].type)))
                concept_params.remove(faov_brw[0].concept_faov_id.id)
                name_concepts['name_concepts'].update({faov_brw[0].concept_faov_id.id: faov_brw[0].id})
            
            if  sso_id:
                sso_brw = parameter_obj.browse(cr, uid, sso_id)
                if not sso_brw[0].concept_sso_id:
                    raise osv.except_osv(_('ERROR!'), _('No hay un concepto %s \
                      asociado para el parametro %s' %(concept_name, sso_brw[0].type)))
                concept_params.remove(sso_brw[0].concept_sso_id.id)
                name_concepts['name_concepts'].update({sso_brw[0].concept_sso_id.id: sso_brw[0].id})
                
            if  jubilacion_id:
                jubilacion_brw = parameter_obj.browse(cr, uid, jubilacion_id)
                if not jubilacion_brw[0].concept_jubilacion_id:
                    raise osv.except_osv(_('ERROR!'), _('No hay un concepto %s \
                      asociado para el parametro %s' %(concept_name, jubilacion_brw[0].type)))
                concept_params.remove(jubilacion_brw[0].concept_jubilacion_id.id)
                name_concepts['name_concepts'].update({jubilacion_brw[0].concept_jubilacion_id.id: jubilacion_brw[0].id})
                
            if  caja_ahorro_id:
                caja_ahorro_brw = parameter_obj.browse(cr, uid, caja_ahorro_id)
                if not caja_ahorro_brw[0].concepto_caja_ahorro_id:
                    raise osv.except_osv(_('ERROR!'), _('No hay un concepto %s \
                      asociado para el parametro %s' %(concept_name, caja_ahorro_brw[0].type)))
                concept_params.remove(caja_ahorro_brw[0].concepto_caja_ahorro_id.id)
                name_concepts['name_concepts'].update({caja_ahorro_brw[0].concepto_caja_ahorro_id.id:caja_ahorro_brw[0].id})
            
            if  regimen_id:
                regimen_brw = parameter_obj.browse(cr, uid, regimen_id)
                if not regimen_brw[0].concepto_prestacional_emp_id:
                    raise osv.except_osv(_('ERROR!'), _('No hay un concepto %s \
                      asociado para el parametro %s' %(concept_name, regimen_brw[0].type)))
                concept_params.remove(regimen_brw[0].concepto_prestacional_emp_id.id)
                name_concepts['name_concepts'].update({regimen_brw[0].concepto_prestacional_emp_id.id:regimen_brw[0].id})
            
            if concepto in concept_params:
               busqueda = concept_params.index(concepto)
               busqueda = concept_params[busqueda]
                
            if not faov_id:
                if busqueda == concepto:
                    raise osv.except_osv(_('ERROR!'), _('No se definio el \
                      parametro para el concepto %s' %concept_name))
            
            if not jubilacion_id:
                if busqueda == concepto:
                    raise osv.except_osv(_('ERROR!'), _('No se definio el \
                      parametro para el concepto %s' %concept_name))
           
            if not sso_id:
                if busqueda == concepto:
                    raise osv.except_osv(_('ERROR!'), _('No se definio el \
                      parametro para el concepto %s' %concept_name))
           
            if not caja_ahorro_id:
                if busqueda == concepto:
                    raise osv.except_osv(_('ERROR!'), _('No se definio el \
                      parametro para el concepto %s' %concept_name))
               
            if not regimen_id:
                if busqueda == concepto:
                    raise osv.except_osv(_('ERROR!'), _('No se definio el \
                      parametro para el concepto %s' %concept_name))
        
       
        data = {
            'ids': context.get('active_ids', []),
            'model': 'hr.process',
            'form': self.read(cr, uid, ids, [], context = context )[0]
        }

        data['form']['month_id'] = paid_brw.month_id.id
        data['form']['payroll_id'] = paid_brw.payroll_id.id
        data['form']['concept_id'] = paid_brw.concept_id.id
        if paid_brw.sede_ids:
            data['form']['sede_ids'] = sedes
        else:
            data['form']['sede_ids'] = 0
        data['form'].update(name_concepts)
        data['form']['hr_ids'] = context.get('active_ids')
        return {'type': 'ir.actions.report.xml', 'report_name': 'hr.listado.conceptos', 
          'datas': data}

hr_listado_conceptos()
