#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta
from lxml import etree
import base64
import unicodedata
from osv import fields, osv
from tools.translate import _
import math

class hr_listado_conceptos_report(report_sxw.rml_parse):

    _name= 'hr.listado.conceptos'
    def __init__(self, cr, uid, name, context):
        super(hr_listado_conceptos_report, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {
            'get_empresa':self.get_empresa,
            'create_lista_concepto':self.create_lista_concepto,
            'get_mes':self.get_mes,
            'get_concepto':self.get_concepto,
            'get_sedes':self.get_sedes,
            'get_total':self.get_total,
            'get_final_date':self.get_final_date,
            'get_nomina':self.get_nomina,
        })
        self.context= context
        self.ids= context.get('active_ids')

    def create_lista_concepto(self, valor, context=None):
        if context is None:
            context = {}
        line_ids = []
        res = {}
        res1 = {}
        hr_sede_brw = False
        hr_month_obj = self.pool.get('hr.month')
        calendar_obj = self.pool.get('hr.payment.calendar')
        hr_monthr_brw = hr_month_obj.browse(self.cr, self.uid, valor['month_id'])
        hr_payroll_obj = self.pool.get('hr.payroll')
        hr_concept_obj = self.pool.get('hr.concept')
        hr_sede_obj = self.pool.get('hr.sede')
        hr_concept_brw = hr_concept_obj.browse(self.cr, self.uid, valor['concept_id'])
        moday_mounth = {1:'monday_first_fortnight', 2:'monday_second_fortnight'}
        if valor['sede_ids']:
            hr_sede_brw = hr_sede_obj.browse(self.cr, self.uid, valor['sede_ids'])
        period_brw = hr_monthr_brw.hr_period_ids
        if valor['payroll_id']:
            hr_payroll_brw = hr_payroll_obj.browse(self.cr, self.uid, 
              valor['payroll_id'])
            calendars_payroll_ids = calendar_obj.search(self.cr, self.uid, [('hr_payroll_ids','in',hr_payroll_brw.id),
              '|',('active','=',True),('active','=',False)])
            calendars_payroll_brw = calendar_obj.browse(self.cr, self.uid, calendars_payroll_ids)
            periods_payroll_brw = []
            for c in calendars_payroll_brw:
                periods_payroll_brw = periods_payroll_brw + c.hr_period_ids
            period_brw = list(set(periods_payroll_brw) & set(period_brw))

        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(self.cr, self.uid, 
              [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(self.cr, 
              self.uid, process_ids)
        process_ids = [x.id for x in process_list]
        concept_id = hr_concept_brw
        if hr_sede_brw:
            line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, 
              [('code','=',concept_id.code),('sede_id','in',valor['sede_ids']),
              ('process_id','in',process_ids)])
        else:
            line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, 
              [('code','=',concept_id.code),('process_id','in',process_ids)])
        
        if valor['concept_id'] in valor['name_concepts']:
            parameter_obj = self.pool.get('hr.parameters')
            acum = {}
            sum_concept = {}
            ordenador = {}
            salida = []
            concept_acum = {'datos':[]}
            payrrol_employee = {}
            parameter_id = valor['name_concepts'][valor['concept_id']]
            parameter_brw = parameter_obj.browse(self.cr, self.uid, parameter_id)
            
            aporte_id = parameter_brw.concept_aporte_compania_id.id
            if not aporte_id:
                raise osv.except_osv(_('ERROR!'), _('No se definio el campo \
                  aporte empresa para el parametro %s'%parameter_brw.type))
           
            base_id = parameter_brw.concept_base_id.id
            if not base_id:
                raise osv.except_osv(_('ERROR!'), _('No se definio el \
                  concepto base para el parametro %s'%parameter_brw.type))
          
            concepto = concept_id.id
            concept_list = []
            concept_list.append(aporte_id)
            concept_list.append(base_id)
            concept_list.append(concepto)
            payslib_obj = self.pool.get('hr.payslip.line')
            if hr_sede_brw:
                payslips_ids = payslib_obj.search(self.cr, self.uid, 
                  [('concept_id','in', concept_list),('sede_id','in',valor['sede_ids']),
                  ('process_id','in',process_ids)])
            else:
                
                payslips_ids = payslib_obj.search(self.cr, self.uid, 
                  [('concept_id','in', concept_list),('process_id','in',process_ids)])
            
            if not payslips_ids:
                raise osv.except_osv(_('ERROR!'), _('No existen lineas de hoja \
                  de pago para el concepto %s '%concept_id.name ))
            
            lunes_dict = {}
            for p in payslib_obj.browse(self.cr, self.uid, payslips_ids):
                lunes_dict[p.employee_id.id] = 1
                for period in p.process_id.hr_period_ids:
                    if period.type == 'mensual':
                       lunes_dict[p.employee_id.id] = getattr(hr_monthr_brw, moday_mounth[period.period_in_month])
                payrrol_employee[p.employee_id.id] = p.process_id.hr_payroll_ids[0].code
                concept_acum['datos'].append({'empleado':(p.employee_id.cod_number, 
                  p.employee_id.identification_id, p.employee_id.name, p.employee_id.id), 
                  'concepto':{'name':p.concept_id.id, 'total': round(p.total, 2)}})
            
            for i in concept_acum['datos']:
                acum[i['empleado']] = []
            
            for i in concept_acum['datos']:
                if i['empleado'] in acum:
                    acum[i['empleado']].append(i['concepto'])
                   
            
            for i in acum:
                for n in acum[i]:
                    sum_concept[i, n['name']] = [0.00]
           
            for i in acum:
                for n in acum[i]:
                    if (i, n['name']) in sum_concept:
                        sum_concept[(i, n['name'])].append(n['total'])
           
            for i in sum_concept:
                ordenador[i[0]] = []
          
            for i in sum_concept:
                ordenador[i[0]].append({i[1]:sum(sum_concept[i])}) 
           
            for i in ordenador:
                ordenador[i].sort()
            
            concept_list.sort()
            for i in ordenador:
                base_v = 0.00
                concepto_v = 0.00
                aporte_empresa_v = 0.00
                
                if parameter_brw.type == 'concepto_caja_ahorro':
                    concepto_porc_ca_id = parameter_brw.concepto_porc_caja_ahorro_id
                    attr_porc = self.pool.get('hr.attribute').search(self.cr, self.uid, 
                      [('employee_id','=',i[3]),('concept_id','=',concepto_porc_ca_id.id),
                      '|',('active','=',True),('active','=',False)], order='date_start desc')
                for n in ordenador[i]:
                    keys = n.keys()
                    if base_id in keys:
                        base_v = n[base_id]
                    if concepto in keys:
                        concepto_v =  n[concepto]
                    if aporte_id in keys:
                        aporte_empresa_v = n[aporte_id]
                        
                
                aporte_traba = round(concepto_v, 2)
                monto = aporte_traba + aporte_empresa_v
                
                if aporte_traba == 0.0:
                    continue
                    
                if parameter_brw.type == 'concepto_caja_ahorro':
                    empleado_porc = empresa_porc = self.pool.get('hr.attribute').browse(self.cr, 
                      self.uid, attr_porc[0]).amount if attr_porc \
                      else '--'
                elif parameter_brw.type == 'concepto_jubilacion':
                    base_v = round((100*aporte_traba)/3.0, 2)
                    empleado_porc = 3.0
                    empresa_porc = 3.0
                    
                elif parameter_brw.type == 'concepto_sso':
                    get_porcen_aporte = self.get_porcen_aporte
                    empleado_porc = round(get_porcen_aporte(base_v, aporte_traba, payrrol_employee[i[3]], lunes_dict[i[3]]) * 100, 2)
                    empresa_porc = round(get_porcen_aporte(base_v, aporte_empresa_v, payrrol_employee[i[3]], lunes_dict[i[3]]) * 100, 2)
                else:
                    empleado_porc = round((aporte_traba*100)/base_v)
                    empresa_porc = round((aporte_empresa_v*100)/base_v)
                l = [ i[0], i[1], i[2],  base_v, empleado_porc, aporte_traba, 
                  empresa_porc, aporte_empresa_v, round(monto, 2)]     
                salida.append(l)   
            
            if not salida:
                raise osv.except_osv(_('ERROR!'), _('Reporte vacio o mal \
                  formado por favor revisar la configuracion del parametro \
                  asociado al concepto %s' %concept_id.name))
            return salida                  
           
       
        if not line_ids:
            raise osv.except_osv(_('ERROR!'), _('No existen líneas de pago asociadas al concepto'))
        line_brw = self.pool.get('hr.payslip.line').browse(self.cr, self.uid, line_ids)
        
        for row in line_brw:
            if not (row.employee_id.cod_number, row.employee_id.identification_id, 
              row.employee_id.name) in res:
                res[row.employee_id.cod_number, row.employee_id.identification_id, 
                  row.employee_id.name] = row.total
            else:
                res[row.employee_id.cod_number, row.employee_id.identification_id, row.employee_id.name] = \
                    res[row.employee_id.cod_number, row.employee_id.identification_id, 
                    row.employee_id.name] + row.total    
        lista =[]
        l1 =[]
        for val in res.keys():
            l1 = [val[0], val[1], val[2], res[val]]
            lista.append(l1)
        return lista
    
        
        
    def get_total(self, valor, context=None):
        if context is None:
            context = {}
        line_ids = []
        hr_sede_brw = False
        res = {}
        hr_month_obj = self.pool.get('hr.month')
        calendar_obj = self.pool.get('hr.payment.calendar')
        hr_monthr_brw = hr_month_obj.browse(self.cr, self.uid, valor['month_id'])
        hr_payroll_obj = self.pool.get('hr.payroll')
        hr_concept_obj = self.pool.get('hr.concept')
        hr_sede_obj = self.pool.get('hr.sede')
        hr_concept_brw = hr_concept_obj.browse(self.cr, self.uid, valor['concept_id'])
        if valor['sede_ids']:
            hr_sede_brw = hr_sede_obj.browse(self.cr, self.uid, valor['sede_ids'])
        period_brw = hr_monthr_brw.hr_period_ids        
        if valor['payroll_id']:
            hr_payroll_brw = hr_payroll_obj.browse(self.cr, self.uid, 
              valor['payroll_id'])
            calendars_payroll_ids = calendar_obj.search(self.cr, self.uid, [('hr_payroll_ids','in',hr_payroll_brw.id),
              '|',('active','=',True),('active','=',False)])
            calendars_payroll_brw = calendar_obj.browse(self.cr, self.uid, calendars_payroll_ids)
            periods_payroll_brw = []
            for c in calendars_payroll_brw:
                periods_payroll_brw = periods_payroll_brw + c.hr_period_ids
            period_brw = list(set(periods_payroll_brw) & set(period_brw))
        
        process_list = []
        for period in period_brw:
            process_ids = self.pool.get('hr.process').search(self.cr, 
              self.uid, [('hr_period_ids','=', period.id),('state','=', 'done')])
            process_list = process_list + self.pool.get('hr.process').browse(self.cr, 
              self.uid, process_ids)
        process_ids = [x.id for x in process_list]
        concept_id = hr_concept_brw
        
        if hr_sede_brw:
            line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, 
              [('code','=',concept_id.code),('sede_id','in',valor['sede_ids']),
              ('process_id','in',process_ids)])
        else:
            line_ids = self.pool.get('hr.payslip.line').search(self.cr, self.uid, 
              [('code','=',concept_id.code),('process_id','in',process_ids)])
              
        line_brw = self.pool.get('hr.payslip.line').browse(self.cr, self.uid, 
          line_ids)
        if valor['concept_id'] in valor['name_concepts']:
            parameter_obj = self.pool.get('hr.parameters')
            acum = {}
            sum_concept = {}
            ordenador = {}
            salida = []
            concept_acum = {'datos':[]}
            parameter_id = valor['name_concepts'][valor['concept_id']]
            parameter_brw = parameter_obj.browse(self.cr, self.uid, parameter_id)
            aporte_id = parameter_brw.concept_aporte_compania_id.id
            base_id = parameter_brw.concept_base_id.id
            concepto = concept_id.id
            concept_list = []
            concept_list.append(aporte_id)
            concept_list.append(base_id)
            concept_list.append(concepto)
            payslib_obj = self.pool.get('hr.payslip.line')
            if hr_sede_brw:
                payslips_ids = payslib_obj.search(self.cr, self.uid, 
                  [('concept_id','in', concept_list),('sede_id','in',valor['sede_ids']),
                  ('process_id','in',process_ids)])
            else:
                payslips_ids = payslib_obj.search(self.cr, self.uid, 
                  [('concept_id','in', concept_list),('process_id','in',process_ids)])
            
            for p in payslib_obj.browse(self.cr, self.uid, payslips_ids):
                concept_acum['datos'].append({'empleado':(p.employee_id.cod_number, 
                  p.employee_id.identification_id, p.employee_id.name, 
                  p.employee_id.gender), 
                  'concepto':{'name':p.concept_id.id, 'total': round(p.total, 2)}})
                  
            for i in concept_acum['datos']:
                acum[i['empleado']] = []
            
            for i in concept_acum['datos']:
                if i['empleado'] in acum:
                    acum[i['empleado']].append(i['concepto'])
            
            for i in acum:
                for n in acum[i]:
                    sum_concept[i, n['name']] = [0.00]
           
            for i in acum:
                for n in acum[i]:
                    if (i, n['name']) in sum_concept:
                        sum_concept[(i, n['name'])].append(n['total'])
           
            for i in sum_concept:
                ordenador[i[0]] = []
          
            for i in sum_concept:
                ordenador[i[0]].append({i[1]:sum(sum_concept[i])}) 
           
            for i in ordenador:
                ordenador[i].sort()
           
            concept_list.sort()
            
            total = 0    
            total_aporte_traba = 0    
            total_aporte_empresa = 0
            
            for i in ordenador:
                base_v = 0.00
                concepto_v = 0.00
                aporte_empresa_v = 0.00
            
                for n in ordenador[i]:
                    keys = n.keys()
                    if base_id in keys:
                        base_v = n[base_id]
                    if concepto in keys:
                        concepto_v =  n[concepto]
                    if aporte_id in keys:
                        aporte_empresa_v = n[aporte_id]
                
                aporte_traba = round(concepto_v, 2)
                monto = aporte_traba + aporte_empresa_v
                
                if aporte_traba == 0.0:
                    continue
                  
                total_aporte_traba = total_aporte_traba + aporte_traba   
                total_aporte_empresa = total_aporte_empresa + aporte_empresa_v
                total = total + monto 
                
            result = (round(total, 2),round(total_aporte_traba, 2),round(total_aporte_empresa, 2)) 
            return result
        total = 0
        for line in line_brw:
            total = total + line.total
        total = (round(total, 2),)
        return total


    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),
          ('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
   
    def get_mes(self, valor):
        obj_mes = self.pool.get('hr.month')
        res = {}
        row_brw = obj_mes.browse(self.cr, self.uid, valor['month_id'])
        if not isinstance(row_brw, list):
            row_brw = [row_brw]
        for row in row_brw:
            res = {
            'name':row.name,
            }
        return res
        
        
    def get_concepto(self, valor):
        obj_mes = self.pool.get('hr.concept')
        res = {}
        row_brw = obj_mes.browse(self.cr, self.uid, valor['concept_id'])
        if not isinstance(row_brw, list):
            row_brw = [row_brw]
        for row in row_brw:
            res = {
            'name':row.name,
            }
        return res
        
    def get_sedes(self, valor):
        obj_mes = self.pool.get('hr.sede')
        res = {}
        if valor['sede_ids']:
            row_brw = obj_mes.browse(self.cr, self.uid, valor['sede_ids'])
            row_brw = [x.name for x in row_brw]
            name = ', '.join(row_brw)
            if not isinstance(row_brw, list):
                row_brw = [row_brw]
            for row in row_brw:
                res = {
                    'name':name,
                }
        else:
            res = {
                'name':'Todas las Sedes',
            }
        return res
        
    def get_nomina(self, valor):
        obj_mes = self.pool.get('hr.payroll')
        res = {}
        if valor['payroll_id']:
            row_brw = obj_mes.browse(self.cr, self.uid, valor['payroll_id'])
            res = {
                'name':row_brw.name,
            }
        else:
            res = {
                'name':'Todas las Nominas',
            }
        return res
        
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y %H:%M')
    
    def get_porcen_aporte(self, base_v, aporte, nomina, lunes):
        porcentaje = 0.00
        if nomina != 'ND':
            porcentaje = (aporte * 52) / (lunes*base_v*24)
        else:
            porcentaje = aporte / base_v
        return porcentaje
    


report_sxw.report_sxw('report.hr.listado.conceptos',
        'hr.process',
        parser= hr_listado_conceptos_report,
        rml= 'sisb_nomina/report/hr_listado_conceptos.rml'
    )
