#-*- coding:utf-8 -*-

import time
import locale
import datetime
from report import report_sxw
import time
import pooler
import calendar
import datetime
from osv import fields, osv
from tools.translate import _


class islr_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(islr_report, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'get_employee': self.get_employee,
            'get_periods': self.get_periods,
            'get_empresa':self.get_empresa,
            'get_employee_amount':self.get_employee_amount,
            'gerente_th':self.gerente_th,
            'rif':self.rif,
            'cedula':self.cedula,
            'nacionalidad':self.nacionalidad,
        })
        
        self.acum_glob = {}
        self.dev_islr_acum = 0.0
        self.imp_islr_acum = 0.0
        self.cr = cr 
        self.uid = uid
        self.id = id
       
    
    def rif(self):
        return self.pool.get('res.users').browse(self.cr, self.uid, self.uid).company_id.partner_id.vat[2:]
    
    def cedula(self, employee):
        ced = employee.identification_id
        algo = '{:,}'.format(int(ced))
        return algo.replace(',','.')
    
    def nacionalidad(self, employee):
        if employee.country_id.code == 'VE':
            return 'V-'
        else:
            return 'E-'
    
    def gerente_th(self):
        param_gerente_id = self.pool.get('hr.parameters').search(self.cr, self.uid, [('type', '=', 'gerente_th')])
        if not param_gerente_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para Gerente de Talento Humano. Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Gerente de Talento Humano'))

        gerente_brw = self.pool.get('hr.parameters').browse(self.cr, self.uid, param_gerente_id)[0].gerente
        return gerente_brw
    
    
    def get_employee_amount(self, obj):
        parameter_obj = self.pool.get('hr.parameters')
        param_conceptos_islr = parameter_obj.search(self.cr, self.uid, [('type', '=', 'concepto_islr')])
        lista_imp_islr = []
        if not param_conceptos_islr:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para concepto ISLR Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Concepto I.S.L.R'))

        for i in parameter_obj.browse(self.cr, self.uid, param_conceptos_islr):
            lista_imp_islr.append(i.concept_islr_id.id)
        
        param_conceptos_sislr = parameter_obj.search(self.cr, self.uid, [('type', '=', 'conceptos_deven')])
        lista_sueldo_islr = []
        if not param_conceptos_sislr:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para concepto Sueldo ISLR Ir a \
                            la pestana Configuracion -> Configuraciones de nomina -> Parametros de nomina y \
                            registrar un parametro de tipo Concepto Sueldo I.S.L.R'))
                            
        for i in parameter_obj.browse(self.cr, self.uid, param_conceptos_sislr):
            for n in i.concept_deven_ids:
                lista_sueldo_islr.append(n.id)
       
        
        
        ls = []
        tol_mnths=['Total',0,0,0,0,0,0,0,0,0,0,0,0]
        emp_id = obj.id
        cnt = 1
        tol = 0.0
        for mnth in self.mnths:
            sal = []
            if mnth <> 'None':
               if len(mnth) != 7:
                   mnth = '0' + str(mnth)
               sal_islr = self.calculate_devn(obj, mnth, lista_sueldo_islr)
               imp_islr = self.get_salary_year(obj, mnth, lista_imp_islr)
               month_total = self.name_month(mnth)
               if sal_islr:
                  sal_islr_amount = sal_islr
                  month_total[1] = sal_islr_amount
                  tol += sal_islr_amount
                  self.dev_islr_acum = self.dev_islr_acum + sal_islr_amount
                  month_total[4] =  self.dev_islr_acum  
                  tol_mnths[cnt] = tol_mnths[cnt] + sal_islr_amount
               if imp_islr:
                  imp_islr_amount =  abs(imp_islr) 
                  month_total[3] =imp_islr_amount
                  self.imp_islr_acum = self.imp_islr_acum +  imp_islr_amount
                  month_total[5] = self.imp_islr_acum 
               if sal_islr > 0.0 and imp_islr > 0.0:
                   month_total[2] = self.porc_retencion(sal_islr_amount, imp_islr_amount)
               ls.append(month_total)
        
        self.dev_islr_acum = 0.0
        self.imp_islr_acum  = 0.0
        
     
        return ls
    
    
    def name_month(self, fecha):
        d = datetime.datetime.strptime(fecha, '%m-%Y')
        nombre_mes = d.strftime('%B')
        l = [nombre_mes.title()]
        for i in range(12):
            l.append(0)
        return l
       
    def porc_retencion(self, monto, porcentaje):
        if monto  > 0:
            total = porcentaje * 100 / float(monto)
            return total 
        return 0
        
    def get_employee(self,form):
        result = []
        periods = []
        emp = pooler.get_pool(self.cr.dbname).get('hr.employee')
        emp_ids = form['employee_ids']
        concept = form['param']
        self.param_concept = eval(concept)
        result = emp.browse(self.cr,self.uid, emp_ids)
        return result
    
    def calculate_devn(self, emp, mes, param=None):
        
        if param: 
           param = param
        else:
            param = self.param_concept
        
        process_id = self.get_calc_period(mes)
        
        payment_category = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        parameter_brw = self.pool.get('hr.concept')
        parameter_brw = parameter_brw.browse(self.cr, self.uid, param)
        deduction =  [i.id for i in parameter_brw   if i.type_calc == 'deduction' ]
        allocation = [i.id for i in parameter_brw  if i.type_calc == 'allocation']
        allowance_cat_ids = payment_category.search( self.cr, self.uid, [('concept_id','in', allocation), ('employee_id', '=', emp.id)])
        deduction_cat_ids = payment_category.search( self.cr, self.uid, [('concept_id','in', deduction), ('employee_id', '=', emp.id)])
        payslip_id = payslip.search(self.cr, self.uid, [('employee_id', '=', emp.id), ('state', '=', 'done'), ('hr_process_id', 'in', process_id)])
        payslip_brw = payslip.browse(self.cr, self.uid, payslip_id)
        payslip_line = [n for i in payslip_brw for n in i.line_ids]
        l_allow = [] 
        l_deduction = [] 
        
        if allowance_cat_ids:
           for i in allowance_cat_ids:
               for line in payslip_line:
                   if i == line.id :
                      l_allow.append(line.total)
                       
         
        if deduction_cat_ids:
           for i in deduction_cat_ids:
               for line in payslip_line:
                   if i == line.id :
                      l_deduction.append(line.total)
                       
           
        asignacion = sum(l_allow)
        deduccion =  sum(l_deduction)
        total = asignacion - deduccion
        return total
    
    def get_salary_year(self, emp, mes, param=None):
    
        process_id = self.get_calc_period(mes)
        
        if param: 
           param = param
        else:
            param = self.param_concept
        
        monto_total = 0.0
        payslip_line_obj = self.pool.get('hr.payslip.line')
        payslip_line_search = payslip_line_obj.search(self.cr, self.uid, [('concept_id', 'in', param), ('process_id','in', process_id), ('employee_id','=',emp.id)])
        payslip_line_browse = payslip_line_obj.browse(self.cr, self.uid, payslip_line_search)
        for line in payslip_line_browse:
            monto_total = monto_total + line.total
        
      
        return monto_total
    
    def get_calc_period(self, mnth):
        dates = datetime.datetime.strptime(mnth, '%m-%Y')
        year_id =  self.pool.get('hr.year').search(self.cr, self.uid, [('year','=',dates.year)])
        month_id =  self.pool.get('hr.month').search(self.cr, self.uid, [('month_year','=',dates.month), ('hr_year_id', '=', year_id)])
        period_id =  self.pool.get('hr.period').search(self.cr, self.uid, [('hr_month_id','in',month_id)])
        process_id =  self.pool.get('hr.process').search(self.cr, self.uid, [('hr_period_ids','in',period_id)])
        return process_id
        
    def get_periods(self,form):
        self.mnths =[]
#       Get start year-month-date and end year-month-date
        fy = int(form['date_from'][0:4])
        ly = int(form['date_to'][0:4])

        fm = int(form['date_from'][5:7])
        lm = int(form['date_to'][5:7])
        no_months = (ly-fy)*12+lm-fm + 1
        cm = fm
        cy = fy

#       Get name of the months from integer
        mnth_name = []
        for count in range(0,no_months):
            m = datetime.date(cy, cm, 1).strftime('%b')
            mnth_name.append(m)
            self.mnths.append(str(cm)+'-'+str(cy))

            if cm == 12:
                cm = 0
                cy = ly
            cm = cm +1
        for c in range(0,(12-no_months)):
            mnth_name.append('None')
            self.mnths.append('None')
        
        for mnth in self.mnths:
            if mnth <> 'None':
               if len(mnth) != 7:
                    mnth = '0' + str(mnth)
               self.acum_glob[mnth] = []   
        return [mnth_name]
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res

report_sxw.report_sxw('report.wizard.islr', 'hr.payslip', 'sisb_nomina/report/report_ISLR.rml', parser=islr_report, header=False )


