#!/usr/bin/python
# -*- encoding: utf-8 -*-

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime

class report_aniversario(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(report_aniversario, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'get_mes': self.get_mes,
            'get_nombre': self.get_nombre,
            
            
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
           
            } 
        return res

    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
       
    def get_mes(self, mes_number):
        meses = {1:'ENERO',2:'FEBRERO',3:'MARZO',4:'ABRIL',5:'MAYO',6:'JUNIO',7:'JULIO',8:'AGOSTO',9:'SEPTIEMBRE',10:'OCTUBRE',11:'NOVIEMBRE',12:'DICIEMBRE'}
        if mes_number:
            return meses[mes_number]
        return ""
    
    def get_nombre(self, id_employee):
        query = """SELECT name
                   FROM hr_employee 
                   WHERE id = """ + str(id_employee)
        self.cr.execute(query)
        nombre = self.cr.fetchall()
        if nombre:
            nombre = nombre[0][0]
            return nombre
        return ""
            

report_sxw.report_sxw('report.sisb.aniversario',
    'wizard.report.aniversarios',
    'sisb_nomina/report/report_aniversario.rml',
    parser=report_aniversario)
