#-*- coding:utf-8 -*-

##############################################################################
#
#    OpenERP, Open Source Management Solution
#    Copyright (C) 2004-2009 Tiny SPRL (<http://tiny.be>). All Rights Reserved
#    d$
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import time
import locale
import datetime
from report import report_sxw
import time
import pooler
import calendar
import datetime

class employees_salary_report(report_sxw.rml_parse):

    def __init__(self, cr, uid, name, context):
        super(employees_salary_report, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'get_employee': self.get_employee,
            'get_employee_detail': self.get_employee_detail,
            'cal_monthly_amt': self.cal_monthly_amt,
            'get_periods': self.get_periods,
            'get_total': self.get_total,
            'get_allow': self.get_allow,
            'get_deduct': self.get_deduct,
            'get_other': self.get_other,
            'get_monthly_total': self.get_monthly_total,
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'rif':self.rif,
        })

        self.mnths =[]
        self.allow_list =[]
        self.deduct_list = []
        self.other_list = []
        self.month_total_list =[]
        self.acum_glob = {}
        self.param_concept = []
        self.total=0.00

    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y %H:%M')
    
    def get_periods(self,form):
        self.mnths =[]
#       Get start year-month-date and end year-month-date
        fy = int(form['date_from'][0:4])
        ly = int(form['date_to'][0:4])

        fm = int(form['date_from'][5:7])
        lm = int(form['date_to'][5:7])
        no_months = (ly-fy)*12+lm-fm + 1
        cm = fm
        cy = fy

#       Get name of the months from integer
        mnth_name = []
        for count in range(0,no_months):
            m = datetime.date(cy, cm, 1).strftime('%b')
            mnth_name.append(m)
            self.mnths.append(str(cm)+'-'+str(cy))

            if cm == 12:
                cm = 0
                cy = ly
            cm = cm +1
        for c in range(0,(12-no_months)):
            mnth_name.append('None')
            self.mnths.append('None')
        
        for mnth in self.mnths:
            if mnth <> 'None':
               if len(mnth) != 7:
                    mnth = '0' + str(mnth)
               self.acum_glob[mnth] = []   
        return [mnth_name]

    def get_employee(self,form):
        result = []
        periods = []
        emp = pooler.get_pool(self.cr.dbname).get('hr.employee')
        emp_ids = form['employee_ids']
        concept = form['param']
        self.param_concept = eval(concept)
        result = emp.browse(self.cr,self.uid, emp_ids)
        return result

    def get_employee_detail(self,obj):
        self.month_total_list =['Neto Total',0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00,0.00]
        self.allow_list =[]
        self.deduct_list = []
        self.other_list = []
        allowance_cat_ids =[]
        deduction_cat_ids = []
        other_cat_ids =[]
        self.total = 0.00
      
        payment_category = self.pool.get('hr.payslip.line')
        payslip = self.pool.get('hr.payslip')
        parameter_brw = self.pool.get('hr.concept')
        parameter_brw = parameter_brw.browse(self.cr, self.uid, self.param_concept)
        deduction =  [i.id for i in parameter_brw   if i.type_calc == 'deduction' ]
        allocation = [i.id for i in parameter_brw  if i.type_calc == 'allocation']
        allowance_cat_ids = payment_category.search( self.cr, self.uid, [('concept_id','in', allocation), ('employee_id', '=', obj.id)])
        deduction_cat_ids = payment_category.search( self.cr, self.uid, [('concept_id','in', deduction), ('employee_id', '=', obj.id)])
        #for Basic Salary
        res = []
        basic_flag = False

        if basic_flag:
            self.allow_list.append(res)
        #for allowance

        if allowance_cat_ids:
            for allow in allowance_cat_ids:
                 res = []
                 res = self.cal_monthly_amt(obj.id,allow)
                 all_flag = False
                 for i in range(1,len(res)):
                    if res[i] > 0.0:
                        all_flag = True
                 if all_flag:
                     #~ self.allow_list.append(res)
                     self.total += res[len(res)-1]
        #~ #for Deduction
        if deduction_cat_ids:
            for deduct in deduction_cat_ids:
                 res = []
                 res = self.cal_monthly_amt(obj.id,deduct)
                 ded_flag = False
                 for i in range(1,len(res)):
                    if res[i] > 0.0:
                        ded_flag = True
                 if ded_flag:
                     #~ self.deduct_list.append(res)
                     self.total -= res[len(res)-1]
        
        self.allow_list.append(self.acum_glob)
        self.deduct_list.append(self.acum_glob)
        return None

    def cal_monthly_amt(self,emp_id,category):
        tot = 0.0
        cnt = 1
        result = []
        res ={}
        if not category:
            result.append('Basic Salary')
        else:
            payslip_line_brw = self.pool.get('hr.payslip.line').browse(self.cr, self.uid, category)
            result.append(payslip_line_brw.concept_id.name)
            category_name = {'type': payslip_line_brw.concept_id.type_calc, 'name': payslip_line_brw.concept_id.name}
        for mnth in self.mnths:
            if mnth <> 'None':
                if len(mnth) != 7:
                    mnth = '0' + str(mnth)
                dates = datetime.datetime.strptime(mnth, '%m-%Y')
                year_id =  self.pool.get('hr.year').search(self.cr, self.uid, [('year','=',dates.year)])
                month_id =  self.pool.get('hr.month').search(self.cr, self.uid, [('month_year','=',dates.month), ('hr_year_id', '=', year_id)])
                period_id =  self.pool.get('hr.period').search(self.cr, self.uid, [('hr_month_id','in',month_id)])
                process_id =  self.pool.get('hr.process').search(self.cr, self.uid, [('hr_period_ids','in',period_id)])
                brw = self.pool.get('hr.process').browse(self.cr, self.uid ,process_id )
                payslip_id = self.pool.get('hr.payslip').search(self.cr, self.uid, [('employee_id', '=', emp_id), ('state', '=', 'done'), ('hr_process_id', 'in', process_id)])
            else:
                payslip_id = False
            if payslip_id:
                payslip_obj = self.pool.get('hr.payslip').browse(self.cr, self.uid, payslip_id)
                payslip_obj = [n for i in payslip_obj for n in i.line_ids] 
              
                if not category:
                    tot += payslip_obj.basic
                    res[mnth] = payslip_obj.basic
                    result.append(payslip_obj.basic)
                    self.month_total_list[cnt] = self.month_total_list[cnt] + payslip_obj.basic
                else:
                    append_index = 0
                    for line in payslip_obj:
                        if line.id == category:
                            if category_name['type'] == 'allocation':
                                if res:
                                    self.month_total_list[cnt] = self.month_total_list[cnt] + line.total
                                    result[append_index] += line.total
                                    tot += line.total
                                    res[mnth] = result[append_index]
                                else:
                                    self.month_total_list[cnt] = self.month_total_list[cnt] + line.total
                                    tot += line.total
                                    res[mnth] = line.total
                                    append_index = len(result) - 1
                                    result.append(line.total)
                                    
                                    if mnth in self.acum_glob.keys():
                                       self.acum_glob[mnth].append({'allocation': result})
                                    
                            if category_name['type'] == 'deduction':
                                if res:
                                    self.month_total_list[cnt] = self.month_total_list[cnt] - line.total
                                    result[append_index] += line.total
                                    tot += line.total
                                    res[mnth] = result[append_index]
                                else:
                                    self.month_total_list[cnt] = self.month_total_list[cnt] - line.total
                                    tot += line.total
                                    res[mnth] = line.total
                                    append_index = len(result) - 1
                                    result.append(line.total)
                                    
                                    if mnth in self.acum_glob.keys():
                                      self.acum_glob[mnth].append({'deduction': result})
            else:
                if mnth == 'None':
                    result.append('')
                    res[mnth] = ''
                    self.month_total_list[cnt] = ''
                else:
                    result.append(0.00)
                    res[mnth] = 0.00
            if not res:
                result.append(0.00)
            res = {}
            cnt = cnt + 1
        cnt = 1
        result.append(tot)
        tot = 0.0
        return result

    def calc_lines_concept(self, golb_list, type):
        acum = {}
        salida = []
        position = {}
        resul_dic = {}
        
        
        for key in golb_list:
            for k in key:
                acum[k] = {}
        
        position_item = acum.items()
        position_item.sort()
        
        ind = 0
        for i in position_item:
            position[i[0]] = ind 
            ind  = ind + 1
      
        for key in golb_list:
            for k in key:
                for n in  key[k]:
                    if type in n:
                        v = n[type]
                        acum[k].update({v[0]:[0.0]})
        
        for key in golb_list:
            for k in key:
                for n in key[k]:
                    if type in n:
                        ll = list(set(n[type]))
                        ll.sort() 
                        v = n[type]
                        ll = [i for i in ll if v[0] != i if isinstance(i, float)]
                        for n in ll:
                            acum[k][v[0]].append(n)
       
        
        for key in acum:
            for y in acum[key]:
                acum[key][y] = sum(acum[key][y])
                
        
        l = []
        for key in acum:
            for y in acum[key]:
                resul_dic[y] = [0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0, 0.0]
        
        for key in acum:
            for y in acum[key]:
                resul_dic[y][position[key]] = acum[key][y]                 
            
        for y in resul_dic:
            resul_dic[y].insert(-1, sum(resul_dic[y]))
            resul_dic[y].insert(0, y)
            salida.append(resul_dic[y])
       
        return salida
        
    def get_allow(self):
        salida = [] 
        salida = self.calc_lines_concept(self.allow_list, 'allocation')
        return salida
        

    def get_deduct(self):
        salida = [] 
        salida = self.calc_lines_concept( self.deduct_list, 'deduction')
        return salida

    def get_other(self):
        return self.other_list

    def get_total(self):
        return self.total

    def get_monthly_total(self):
        return self.month_total_list
    
    def company(self):
        return self.pool.get('res.users').browse(self.cr, self.uid, self.uid).company_id
    
    def rif(self):
        return self.pool.get('res.users').browse(self.cr, self.uid, self.uid).company_id.partner_id.vat[2:]
    
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
            

#~ report_sxw.report_sxw('report.employees.salary', 'hr.payslip', 'sisb_nomina/report/report_employees_detail.rml', parser=employees_salary_report, header='internal landscape')
report_sxw.report_sxw('report.employees.salary', 'hr.payslip', 'sisb_nomina/report/report_employees_detail.rml', parser=employees_salary_report, header=False )

# vim:expandtab:smartindent:tabstop=4:softtabstop=4:shiftwidth=4:
