#~ # -*- coding: utf-8 -*-
from report import report_sxw
import time
from datetime import datetime, timedelta
from lxml import etree
import base64
import unicodedata
from osv import fields, osv
from tools.translate import _
import math

class report_pago_guarderia(report_sxw.rml_parse):

    _name= 'report.pago.guarderia'
    def __init__(self, cr, uid, name, context):
        super(report_pago_guarderia, self).__init__(cr, uid, name, context)
        self.localcontext.update(
        {	
            'get_empresa': self._get_empresa,
            'get_final_date': self._get_final_date,
            'get_mes': self._get_mes,
            'get_empleados':self._get_empleados,
            'get_data': self._get_data,
        })
        self.context= context
        self.ids= context.get('active_ids')

    def _get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),
          ('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res

    def _get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y %H:%M')
        
    def _get_mes(self, form):
        mes_id = form['month_id']
        mes_brw = self.pool.get('hr.month').browse(self.cr, self.uid, mes_id)
        return mes_brw.name
        
    def _get_empleados(self, form):
        empleados_ids = form['employee_ids']
        if not isinstance(empleados_ids, list):
            empleados_ids = [empleados_ids]
        empleados_brw = self.pool.get('hr.employee').browse(self.cr, self.uid, empleados_ids)
        return empleados_brw

    def _get_data(self, cod_trabajador, mes):
        data = []
        
        self.cr.execute("""
            select distinct he.name as trabajador, hef.name as hijo, rp.name as guarderia,
                ai.reference as ref_factura, ai.date_document as fecha_factura, av.reference as ref_op,
                av.date as fecha_op, hpl.total
                from hr_payslip_line hpl 
                join hr_payslip hp on hp.id = hpl.slip_id
                join hr_employee he on he.id = hpl.employee_id
                join hr_employee_family hef on hef.id = hpl.employee_family_id
                join hr_process hpr on hpr.id = hpl.process_id
                join hr_period_process_rel hppr on hppr.process_id = hpr.id
                join hr_period hpe on hpe.id = hppr.period_id
                join hr_month hm on hm.id = hpe.hr_month_id and hm.name = '%s'
                join hr_guarderias hg on hg.id = hef.guarderia_id
                join res_partner rp on rp.id = hg.partner_id
                left join account_invoice ai on ai.payslip_id = hp.id and ai.state in ('open','paid')
                left join account_voucher_line avl on avl.invoice_id = ai.id
                left join account_voucher av on av.id = avl.voucher_id and av.state = 'posted'
                where he.cod_number = '%s' and hpr.type = 'guarderias'
        """%(mes, cod_trabajador))
        
        data = self.cr.dictfetchall()
        if not data:
            data = [{'no_data': False}]
        else:
            data[0].update({'no_data': True})
        print 'data ', data
        return data
        
        
report_sxw.report_sxw('report.report.pago.guarderia',
        'hr.employee',
        parser= report_pago_guarderia,
        rml= 'sisb_nomina/report/report_pago_guarderia.rml'
    )
