#!/usr/bin/env python
# -*- coding: utf-8 -*--

from report import report_sxw
import datetime
from datetime import datetime
import pooler
from osv import osv

class csv_reporte_general(report_sxw.rml_parse):
    _name =  'csv.reporte.general'
    
    def __init__(self, cr, uid, name, context):
        super(csv_reporte_general, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'cvr_date':self.cvr_date,
            
        })
        
        
        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        return  datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%Y%m%d')
        
    
    
report_sxw = report_sxw.report_sxw     
   
   
class TxtParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False,
        header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
    
    
    def cvr_departament(self, id_depart, cr, uid):
        string = ""
        pool= pooler.get_pool(cr.dbname)    
        avl_obj=pool.get('hr.department')
        rea = avl_obj.read(cr, uid, id_depart)
        nombre = rea['complete_name']
        
        lista =  nombre.split("/")
        lista.pop(0)
        for x in lista:
            if string == "":
                string = x
            else:
                string = string + "/" + x
        return string
    
    def create_single_pdf(self, cr, uid, ids, data, report_xml, context=None):
        """generate the csv"""
       
        if context is None:
            context={}

        self.parser_instance = self.parser(
                                            cr,
                                            uid,
                                            self.name2,
                                            context=context)
        
        csv = ""
        d = 0
        dep = 0
        for i in data['title']:
            for x in i:
                d = d + 1
                if x == 'departamento':
                    dep = d - 1
            x = '|'.join(i)
            csv = csv + x + '\n'
        
        for i in data['form']:
            if dep == 0:
                x = '|'.join(i)
                csv = csv + x + '\n'
            else:
                if i[dep] != "":
                    i[dep] = self.cvr_departament(int(i[dep]), cr, 1)
                    x = '|'.join(i)
                    csv = csv + x + '\n'
                else:
                    x = '|'.join(i)
                    csv = csv + x + '\n'
        
        
        return (csv,'csv')

TxtParser(
    'report.general.trabajadores',
    'hr.employee',
    'sisb_nomina/report/reporte_general.rml',
    parser=csv_reporte_general, header=False)
