#-*- coding:utf-8 -*-

import netsvc
import time
from tools.translate import _
from osv import fields, osv
import datetime


class reporte_mensual_conceptos_wizard(osv.osv_memory):
    _name = 'reporte.mensual.conceptos.wizard'
    _description = 'Reporte mensual de conceptos'

    def _select_types(self, cr, uid, context=None):
        if context is None:
            context = {}
        res = [('nomina', 'Nómina'),
            ('vacaciones', 'Vacaciones'),
            ('utilidades', 'Utilidades'),
            ('prestaciones', 'Prestaciones sociales'),
            ('guarderias', 'Pago de guarderías'),
            ('anticipos', 'Pago de anticipos'),
            ('bono_alimentacion', 'Pago bono alimentación'),
            ('pago_especial', 'Pagos especiales'),
        ]

        parameter_obj = self.pool.get('hr.parameters')
        param_type_process_ids = parameter_obj.search(cr, uid, [('type', '=', 'tipo_proceso')])
        for param_type_process in parameter_obj.browse(cr, uid, param_type_process_ids):
            res.append((param_type_process.type_process, param_type_process.type_process))

        return res
        
    _columns = {
        'month_id': fields.many2one('hr.month', 'Mes', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nomina', required=True),
        'type': fields.selection(_select_types, "Tipo proceso", required=True, size=64),
        'sede_ids':fields.many2many('hr.sede', 'hr_rep_mensual_concept_rel', 
          'report_id', 'sede_id', 'Sedes'),
    }
    
    def reporte_mensual_conceptos_wizard(self, cr, uid, ids, context=None):
        report_wizard_brw = self.browse(cr, uid, ids)[0]
        data = {
            'ids': context.get('active_ids', []),
            'model': 'hr.process',
            'form': self.read(cr, uid, ids, [], context = context )[0]
        }
        
        data['form']['month_id'] = report_wizard_brw.month_id.id
        data['form']['payroll_id'] = report_wizard_brw.payroll_id.id
        data['form']['type'] = report_wizard_brw.type
        data['form']['sede_ids'] = [x.id for x in report_wizard_brw.sede_ids]

        data['form']['ids'] = context.get('active_ids')
        return {'type': 'ir.actions.report.xml', 'report_name': 'reporte.mensual.conceptos', 
          'datas': data}

reporte_mensual_conceptos_wizard()
