from report import report_sxw
import datetime
from datetime import datetime


class report_txt_faov(report_sxw.rml_parse):
    _name =  'report.txt.faov'
    
    def __init__(self, cr, uid, name, context):
        super(report_txt_faov, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'cvr_date':self.cvr_date,
            
        })
        #~ print name
        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        return  datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%Y%m%d')    
    
report_sxw = report_sxw.report_sxw     
   
class TxtParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False,
        header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
    
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context=None):
        """generate the PDF"""
        
        if context is None:
            context={}

        if report_xml.report_type != 'txt':
            return super(TxtParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)

        self.parser_instance = self.parser(
                                            cursor,
                                            uid,
                                            self.name2,
                                            context=context
                                        )
        if report_xml.report_type == 'txt':
            pdf = ''
            sal = data['form']['salida']
            for o in sal:
                txt = '%s,%s,%s,%s,%s,%s,%s,%s,%s'%(o['nac'],o['cedula'],o['p_nombre'],o['s_nombre'],o['p_apellido'],o['s_apellido'],o['total'],o['date_start'],o['date_end'])
                pdf = pdf + txt + '\n'
        return (pdf, 'txt')        
                

TxtParser(
    'report.txt.faov',
    'wizard.generador.txt.FAOV',
    'sisb_nomina/report/txt_faov.rml',
    parser=report_txt_faov, header=False)
