#!/usr/bin/env python
# -*- coding: utf-8 -*--


from datetime import datetime
from dateutil import relativedelta
import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import logging
import base64
import os
import math
import calendar
import re 
import unicodedata
from report import report_sxw
import datetime
from datetime import datetime


class report_txt_sso(report_sxw.rml_parse):
    _name =  'report.txt.sso'
    
    def __init__(self, cr, uid, name, context):
        
        super(report_txt_sso, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'get_empresa':self.get_empresa,
            'get_final_date':self.get_final_date,
            'cvr_date':self.cvr_date,
            
        })

        self.context = context

    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
    
    def get_final_date(self):
        return datetime.now().strftime('%d/%m/%Y %H:%M')    
    
    def cvr_date(self, fecha):
        return  datetime.datetime.strptime(fecha, '%Y/%m/%d').strftime('%Y%m%d')    
    
report_sxw = report_sxw.report_sxw     
   
class TxtParser(report_sxw):
    """Custom class that use webkit to render HTML reports
       Code partially taken from report openoffice. Thanks guys :)
    """
    def __init__(self, name, table, rml=False, parser=False,
        header=True, store=False):
        self.parser_instance = False
        self.localcontext={}
        
        report_sxw.__init__(self, name, table, rml, parser,
            header, store)
    
    
    def calculo(self, monto):
        monto = str(round(monto, 2)).split('.')
        if len(monto[1]) <= 1:
            monto = str(monto[0])
            return monto
        else:
            monto = monto[0]+"."+monto[1]
            monto = monto.replace('.',',')
            return monto
            
    
    def create_single_pdf(self, cursor, uid, ids, data, report_xml, context=None):
        """generate the PDF"""
        
        if context is None:
            context={}

        if report_xml.report_type != 'txt':
            return super(TxtParser,self).create_single_pdf(cursor, uid, ids, data, report_xml, context=context)

        self.parser_instance = self.parser(
                                            cursor,
                                            uid,
                                            self.name2,
                                            context=context
                                        )
        if report_xml.report_type == 'txt':
            f = 0
            ff = 1
            pdf = ''
            sal = data['form']
            for o in sal:
                
                vals = sal[o]
                if len(vals['monto']) > 1:
                    
                    if len(vals['date_start']) > 1:
                            vals['date_start'].sort()
                            a = vals['date_start']
                            b = [datetime.strptime(x,'%d/%m/%Y') for x in a]
                            b.sort()
                            a = [x.strftime('%d/%m/%Y') for x in b]
                            m = vals['monto']
                            mm = [float(x) for x in m]
                            res = len(vals['monto']) / 2
                            if res > 1:
                                for p in range(res):
                                    txt = '%s;%s;%s;%s;%s;%s'%(o[1], o[2], o[3], self.calculo(mm[f]), self.calculo(mm[ff]),a[-1] )                            
                                    pdf = pdf + txt + '\n'
                                    f = f + 2
                                    ff = ff + 2
                            else:
                                txt = '%s;%s;%s;%s;%s;%s'%(o[1], o[2], o[3], self.calculo(mm[0]), self.calculo(mm[1]),a[-1] )                            
                                pdf = pdf + txt + '\n'
                            f = 0
                            ff = 1
        return (pdf, 'txt')        

TxtParser(
    'report.txt.sso',
    'wizard.generador.txt.sso',
    'sisb_nomina/report/txt_variacion_salario.rml',
    parser=report_txt_sso, header=False)
