#-*- coding:utf-8 -*-
#!/usr/bin/env python

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv,fields
from tools.translate import _
import pooler
import time
import unicodedata
import re
import datetime

class cargos_report_wizard(osv.osv_memory):
    _name = "cargos.report.wizard"
    _description = 'Wizard para generar REPORTE de cargos pre-vistos y ocupados'
    
        
    _columns = {

    'department_id': fields.many2one('hr.department', 'Departamento'),
    'job_id': fields.many2one('hr.job', 'Cargo'),
   
    'all_departament': fields.boolean(''),
    'all_job': fields.boolean(''),
    
    }
    _defaults = {
        'all_job': True, 'all_departament':True, 
    }
    

    def generar_reporte_cargos(self, cr, uid, ids, context=None):
        """reporte de cargos
        dicho codigo se basa en hr_departament and h_jod
        """
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        
        department_id = [brw.department_id.id]
        job_id = [brw.job_id.id]
        
        
        all_departament = brw.all_departament
        all_job = brw.all_job
        
        obj_departament = self.pool.get('hr.department')
        obj_job = self.pool.get('hr.job')
        
        """se verifican que los check estem o no tildados por el usuario"""
        
        if all_departament:
            department_id = obj_departament.search(cr, uid, [])
        if all_job:
            job_id = obj_job.search(cr, uid, [])
            
        departament_ids_brw = obj_departament.browse(cr, uid, department_id)
        
        acumulador = {}
        
        """obtengo los ids de todos los departamentos mediante departament_ids_brw"""
        """creo un dicc para establecer los datos y recorrerlos acumulador"""
        
        if (all_departament and all_job) or (not all_departament and all_job):
            
            for i in departament_ids_brw:
                rea = obj_departament.read(self.cr, self.uid, i.id)
                acumulador[rea['complete_name']] = self.job(i.id) 
                if acumulador[rea['complete_name']] == []:
                    del acumulador[rea['complete_name']]
            
        if all_departament and not all_job:
            for i in departament_ids_brw:
                rea = obj_departament.read(self.cr, self.uid, i.id)
                acumulador[rea['complete_name']] = self.job2(i.id, job_id)
                if acumulador[rea['complete_name']] == []:
                    del acumulador[rea['complete_name']]
            
    
        order_list = []
        totales= {}
        """se creo una lista para agregar los datos depues del ordemamiento alfabetico"""
        """se crea otro diccionario con la misma llave para enviar los totales"""
        
        for x in sorted(acumulador.iterkeys()):
            s1=0
            s2=0
            s3=0
            for i in acumulador[x]:
                s1=s1+i[1]
                s2=s2+i[2]
                s3=s3+i[3]
            totales[x]=[s1,s2,s3]
            order_list.append({x:acumulador[x]})

        data={}
        
        if order_list:
            data['form'] = order_list
            data['totales'] = totales
        else:
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!'))
        
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sisb.cargos',
            'datas':data, 
            }
    
    
    
    def job(self, id):
        lista = []
        
        obj_job = self.pool.get('hr.job')
        job_ids = obj_job.search(self.cr, self.uid, [('department_id', '=', id)])
        job_ids_brw= obj_job.browse(self.cr, self.uid, job_ids)
        for i in job_ids_brw:
            
            lista.append((i.name, i.expected_employees, i.no_of_employee, i.no_of_recruitment))
     
        return lista
        
    def job2(self, id, type_job_id):
        lista = []
        obj_job = self.pool.get('hr.job')
        job_ids = obj_job.search(self.cr, self.uid, [('department_id', '=', id),('type_job_id', '=', type_job_id)])
        job_ids_brw= obj_job.browse(self.cr, self.uid, job_ids)
       
        for i in job_ids_brw:
            
            lista.append((i.name, i.expected_employees, i.no_of_employee, i.no_of_recruitment))
        
        return lista
        
        
cargos_report_wizard()
