#-*- coding:utf-8 -*-
#!/usr/bin/env python

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv,fields
from tools.translate import _
import pooler
import time
import unicodedata
import re
import datetime

class centro_costo_wizard(osv.osv_memory):
    _name = "centro.costo.wizard"
    _description = 'Wizard para generar REPORTE de trabajadores por centro de costos'
    
    _columns = {
    'mes_id': fields.many2one('hr.month', 'Mes', required=True),
    }
   
    
    def generar_reporte_centro_costo(self, cr, uid, ids, context=None):
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        mes_id = brw.mes_id
        
        query = """select id from  hr_period 
        where hr_month_id = %s """
        self.cr.execute(query %int(mes_id.id))
        res_query = self.cr.fetchall()
        
        lista = []
        
        ########      REPORTE GENERAL     ##############################
        
        for i in res_query:
                query = """ select hp.id from hr_period_process_rel hpp, hr_process hp
                        where hpp.period_id = %s and hpp.process_id = hp.id and hp.type = 'prestaciones' """
                self.cr.execute(query %int(i[0]))
                res = self.cr.fetchall()
                for x in res:
                    lista.append(x)
        lis = self.quitarDuplicados(lista)
        
        dicc= {}
        for i in lis:
            query = """ select department_id from hr_payslip where hr_process_id = %s"""
            self.cr.execute(query %int(i[0]))
            res = self.cr.fetchall()
           
            for x in res:
                query = """ select aaa.name, aaa.code from 
                        hr_department hd,
                        account_analytic_account aaa 
                        where hd.departament_analytic_account_id = aaa.id and hd.id = %s """
                self.cr.execute(query %int(x[0]))
                analytic_id = self.cr.fetchall()
                
                if analytic_id[0] in dicc:
                    dicc[analytic_id[0]] += 1
                    
                else:
                    dicc[analytic_id[0]] = 1
                   
        order_list=[]
        for x in sorted(dicc.iterkeys()):
            order_list.append({x:dicc[x]})
        
        suma= 0
        for i in order_list:
            for x in i:
                suma = suma + int(i[x])

        ################################################################

        ######      PROCESOS DE NOMINA   ###############################

        for i in res_query:
            query = """ select hp.id, hp.name from hr_period_process_rel hpp, hr_process hp
                    where hpp.period_id = %s and hpp.process_id = hp.id and hp.type = 'nomina' """
            self.cr.execute(query %int(i[0]))
            res = self.cr.fetchall()
            
            for x in res:
                lista.append(x)
        
        proc_nom = {}
        totales={}
        for i in lista:
            if len(i) > 1:
                query = """ select department_id from hr_payslip where type_process = 'nomina' and hr_process_id = %s"""
                self.cr.execute(query %int(i[0]))
                res = self.cr.fetchall()
                
                dicc_={}
                
                for x in res:
                    lista_ordenada=[]
                    query = """ select aaa.name, aaa.code from 
                            hr_department hd,
                            account_analytic_account aaa 
                            where hd.departament_analytic_account_id = aaa.id and hd.id = %s """
                    self.cr.execute(query %int(x[0]))
                    analytic = self.cr.fetchall()
            
                    if analytic[0] in dicc_:
                        dicc_[analytic[-1]] += 1
                    else:
                        dicc_[analytic[-1]] = 1
                        
                    for x in sorted(dicc_.iterkeys()):
                        lista_ordenada.append({x:dicc_[x]})
                
                    if i in proc_nom:
                        proc_nom[i[-1]] = lista_ordenada
                    else:
                        proc_nom[i[-1]] = lista_ordenada
                    
        lista_order = []
        for x in sorted(proc_nom.iterkeys()):
            lista_order.append({x:proc_nom[x]})
        
        dicc_total={}
        
        for i in lista_order:
            for x in i:
                sumas=0
                for p in i[x]:
                    for f in p:
                        sumas = sumas + int(p[f])
                
                    dicc_total[x] = sumas

        #################################################################

        data={}
        
        if order_list:
            data['form'] = order_list
            data['total_general'] = suma
            data['mes'] = mes_id.name.upper()
            data['form_proceso'] = lista_order
            data['dicc_total'] = dicc_total
            
        else:
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!'))
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sisb.centro',
            'datas':data, 
            }
    
        
        
    def quitarDuplicados(self, lst):
         lst = list(set(lst))   
         return lst
        
        
centro_costo_wizard()
