#-*- coding:utf-8 -*-
#!/usr/bin/env python

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

from osv import osv,fields
from tools.translate import _
import pooler
import time
import unicodedata
import re
import datetime

class family_report_wizard(osv.osv_memory):
    _name = "family.report.wizard"
    _description = 'Wizard para generar REPORTE de carga familiar'
    
    
    def _get_age(self, cr, uid, ids, context=None):
        if context is None:
            context = {}
        lista =[]
        for i in range(101):
            lista.append((str(i),str(i)))
        return lista
        
    _columns = {

        'titulo': fields.char('Titulo', size=50),
        'sede_id': fields.many2one('hr.sede', 'Sede', required=True), 
        'nomina_id': fields.many2one('hr.payroll', 'Nómina'),
        'all_sede': fields.boolean(''),
        'all_edad': fields.boolean(''),
        'all_nomina': fields.boolean(''),
        'type_employee': fields.selection([
            ('', ''),
            ('empleado', 'Empleado'),
            ('obrero', 'Obrero'),
            ('vendedor', 'Vendedor'),
        ], 'Tipo trabajador', select=True),
        'relationship': fields.selection(
            [('', ''),
            ('hijo_a', 'Hijo(a)'),
            ('padre/madre', 'Padre/Madre'),
            ('esposo_a', 'Esposo(a)'),
            ('concubino_a', 'Concubino(a)'),], 'Parentesco'),
                        
        'sexo': fields.selection(
            [('', ''),
            ('masculino', 'Masculino'),
            ('femenino', 'Femenino'),], 'Sexo'),               
        'hcm': fields.boolean('HCM'),
        'seg_vida': fields.boolean('Seguro de Vida'),
        'edadd': fields.selection(_get_age, "Edad-Desde", 
          required=False, size=64),
        'edadh': fields.selection(_get_age, "Edad-Hasta", 
          required=False, size=64),
        'guarderia': fields.boolean(''),
    
    }
    _defaults = {
        'all_sede': True, 
        'all_nomina':True, 
        'hcm': False, 
        'all_edad' :True,
        'guarderia' :False,
    }
    

    def generar_reporte_carga_familiar(self, cr, uid, ids, context=None):
        
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        
        sede_id = [brw.sede_id.id]
        nomina_id = [brw.nomina_id.id]
        
        all_edad = brw.all_edad
        all_sede = brw.all_sede
        all_nomina = brw.all_nomina
        titulo = brw.titulo
        
        if all_sede:
            sede_id = self.pool.get('hr.sede').search(cr, uid, [])
            
        if all_nomina:
            nomina_id =  self.pool.get('hr.payroll').search(cr, uid, [])

        obj_employee = self.pool.get('hr.employee')
        obj_employee_departament = self.pool.get('hr.department')
        
        
        if not titulo:
            titulo = "Carga Familiar"
            
        hcm = brw.hcm
        seg_vida = brw.seg_vida
        relationship = brw.relationship
        type_employee = brw.type_employee
        sexo = brw.sexo
        guarderia = brw.guarderia if relationship == 'hijo_a' else False
        
        edadd = brw.edadd
        edadh = brw.edadh
        
        if edadd == False:
            edadd = 1000
        if edadh == False:
            edadh = 1000
        
        if all_edad != True:
            
            if ((edadd != False) and (edadh != False)):
                if edadd == 1000:
                    edadd = 0
                if edadh == 1000:
                    edadh = 0
                if int(edadh) < int(edadd):
                    raise osv.except_osv(_('ERROR!'), _('Edad-Desde \
                      no puede ser mayor a Edad-Hasta!!!'))
        
        if edadd == 0:
            edadd = 1000
        if edadh == 0:
            edadh = 1000

        if not type_employee: 
            employee_id = obj_employee.search(cr, uid, [('hr_sede_id','in', sede_id),
              ('hr_payroll_id', 'in', nomina_id),('state', '!=', 'egresado')])
        else:
            employee_id = obj_employee.search(cr, uid, [('hr_sede_id','in', sede_id),
              ('hr_payroll_id', 'in', nomina_id),('type_employee','=', type_employee),
              ('state', '!=', 'egresado')])
        
        departament_id = obj_employee_departament.search(cr, uid,[])
        departament_id_brw = obj_employee_departament.browse(cr ,uid, departament_id)
        
        browse_id = obj_employee.browse(cr, uid, employee_id)
        acumulador = {}
        
        can_dep=0
        can_total = 0
        dii=[]
        dicc={}
        total_varones = 0
        total_hembras = 0
        total_guarderias = 0
        
        for i in departament_id_brw:
            carga=[]
            rea = obj_employee_departament.read(self.cr, self.uid, i.id)
            acumulador[rea['complete_name']] = [{p.id:self.familiares(p.id, relationship, 
              edadd,edadh, hcm, seg_vida, sexo, all_edad, guarderia)} 
              for p in i.member_ids for n in browse_id if n.id == p.id]
            
            if acumulador[rea['complete_name']] == []:
                del acumulador[rea['complete_name']]
            else:
                for l in acumulador[rea['complete_name']]:
                    for n in l:
                        can_dep = can_dep + len(l[n])
                        if l[n]:
                            carga.append(l)
                            
                        for f in l[n]:
                            total_hembras = total_hembras + 1 if f[2] == 'Femenino' \
                              else total_hembras
                            total_varones = total_varones + 1 if f[2] == 'Masculino' \
                              else total_varones
                            total_guarderias = total_guarderias + 1 if f[7] <> '' \
                              else total_guarderias
                              
                    acumulador[rea['complete_name']] = carga
                
                can_total = can_total + can_dep
                
                dicc[rea['complete_name']]= can_dep
                
                if acumulador[rea['complete_name']] == []:
                    del acumulador[rea['complete_name']]
                    
            can_dep = 0
        
        order_list = []
        totales= {}
        """se creo una lista para agregar los datos depues del ordemamiento alfabetico"""
        """se crea otro diccionario con la misma llave para enviar los totales"""
        
        for x in sorted(acumulador.iterkeys()):
            order_list.append({x:acumulador[x]})
        
        data={}
        
        if acumulador:
            data['form'] = order_list
            data['titulo'] = titulo.upper()
            data['guarderia'] = guarderia
            data['total_hembras'] = total_hembras
            data['total_varones'] = total_varones
            data['total_guarderias'] = total_guarderias
            
        else:
            raise osv.except_osv(_('ERROR!'), _('la combinacion para generar dicho reporte no arrojo ningun resultado!!!'))
        
                
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sisb.familiares',
            'datas':data, 
            }
    
    def familiares(self,employee_id, relationship, edadd, edadh, hcm, seg_vida, sexo, check, guarderia):
        
        lista = []  
        consulta=[]      
        obj_employee_family = self.pool.get('hr.employee.family')
        consulta.append(('employee_id','=', employee_id))
        
        if sexo:
            if sexo == 'masculino':
                sexo = 'male'
            else:
                sexo = 'female'
        
        if not hcm and not seg_vida:
            
            if check:
                if relationship:
                    consulta.append(('relationship','=',relationship))
                if sexo:
                    consulta.append(('gender','=',sexo))
                    
                employee_family_id = obj_employee_family.search(self.cr, self.uid, consulta)   
            
            if not check:
                if relationship:
                    consulta.append(('relationship','=',relationship))
                if edadd:
                    consulta.append(('edad','>=', edadd))
                if edadh:
                    consulta.append(('edad','<=', edadh))
                if sexo:
                    consulta.append(('gender','=',sexo))

                employee_family_id = obj_employee_family.search(self.cr, self.uid, consulta)   
        else:
            consulta.append(('hcm','=', hcm))
            consulta.append(('seg_vida','=', seg_vida))
            
            if check:
                if relationship:
                    consulta.append(('relationship','=',relationship))
                if sexo:
                    consulta.append(('gender','=',sexo))
                
                employee_family_id = obj_employee_family.search(self.cr, self.uid, consulta)   
            
            if not check:
                if edadd:
                    consulta.append(('edad','>=', edadd))
                if edadh:
                    consulta.append(('edad','<=', edadh))
                if relationship:
                    consulta.append(('relationship','=',relationship))
                if sexo:
                    consulta.append(('gender','=',sexo)) 
                employee_family_id = obj_employee_family.search(self.cr, self.uid, consulta)   
                
        family_brw = obj_employee_family.browse(self.cr ,self.uid, employee_family_id)
        
        for i in family_brw:
            if i.gender == 'female':
                genero = 'Femenino'
                if i.relationship == 'esposo_a':parentesco = 'Esposa'
                elif i.relationship == 'hijo_a':parentesco = 'Hija'
                elif i.relationship == 'padre/madre':parentesco = 'Madre'
                elif i.relationship == 'concubino_a':parentesco = 'Concubina'
            else:
                genero = 'Masculino'
                if i.relationship == 'esposo_a':parentesco = 'Esposo'
                elif i.relationship == 'hijo_a':parentesco = 'Hijo'
                elif i.relationship == 'padre/madre':parentesco = 'Padre'
                elif i.relationship == 'concubino_a':parentesco = 'Concubino'
            
            if i.hcm: hcm = 'Si'
            else: hcm = "No"
                
            if i.seg_vida: seg_vida = 'Si'
            else: seg_vida = "No"
            
            if i.identification_id == "0":
                cedula = ""
            else:
                cedula = i.identification_id
                
            guarderia_name = ''
            if guarderia and parentesco in ('Hija', 'Hijo'):
                if i.guarderia_id:
                    guarderia_name = i.guarderia_id.partner_id.name
                    
            lista.append((i.name, cedula, genero, parentesco, i.edad, hcm, seg_vida, guarderia_name))
            lista.sort()
        return lista

family_report_wizard()
