#!/usr/bin/env python
# -*- coding: utf-8 -*--

from time import strftime
from datetime import *
import datetime
from datetime import date
from datetime import datetime, timedelta
import datetime as dt
from dateutil import relativedelta  
import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import logging
import base64
import os
import math
import calendar
import re 
import unicodedata


class wizard_reporte_general(osv.osv_memory):
    _name = 'wizard.reporte.general'
    _description = 'Csv de reporte general de trabajadores'
    _columns = {
    
        'mes_id': fields.many2one('hr.month', 'Mes', required=True), 
        'actual': fields.boolean("Actual"),
        
        'borrador': fields.boolean("Borrador"),
        'activo': fields.boolean("Activo"),
        'vacaciones': fields.boolean("Vacaciones"),
        'reposo': fields.boolean("Reposo"),
        'egresado': fields.boolean("Egresado"),
        
        'codigo': fields.boolean("Codigo"),
        'cedula': fields.boolean("Cedula"),
        'nombre': fields.boolean("Nombre"),
        'fecha_nacimiento': fields.boolean("Fecha de Nacimiento"),
        'edad': fields.boolean("Edad"),
        'inicio_relacion_laboral': fields.boolean("Inicio de la Relacion Laboral"),
        'fin_relacion_laboral': fields.boolean("Fin de la Relacion Laboral"),
        'sueldo': fields.boolean("Sueldo"),
        'sede': fields.boolean("Sede"),
        'nomina': fields.boolean("Nomina"),
        'tiempo_servicio': fields.boolean("Tiempo de Servicio"),
        'fecha_hoy_o_mes': fields.boolean("Fecha"),
        
        'departamento': fields.boolean("Departamento"),
        'cargo': fields.boolean("Cargo"),

    }
    
    _defaults = {
        'actual': True, 'activo': True, 'nombre': True, 'codigo': True, 'cedula': True, 
    }
    
    
    def generar_csv_reporte_general(self, cr, uid, ids, context=None):
        self.cr = cr
        self.uid = uid
        brw = self.browse(cr, uid, ids)[0]
        
        """preparando lista de consulta"""
        estados = []
        
        borrador= brw.borrador
        activo=  brw.activo
        vacaciones=  brw.vacaciones
        reposo= brw.reposo
        egresado= brw.egresado
        mes_id = brw.mes_id
        actual= brw.actual
        codigo = brw.codigo
        cedula= brw.cedula
        nombre= brw.nombre
        fecha_nacimiento= brw.fecha_nacimiento
        edad= brw.edad
        inicio_relacion_laboral= brw.inicio_relacion_laboral
        fin_relacion_laboral= brw.fin_relacion_laboral
        sueldo= brw.sueldo
        sede= brw.sede
        nomina= brw.nomina
        departamento= brw.departamento
        cargo= brw.cargo
        
        tiempo_servicio= brw.tiempo_servicio
        fecha_hoy_o_mes= brw.fecha_hoy_o_mes
        
        if mes_id:
            date_end=""
            year = brw.mes_id.hr_year_id.year 
            month =  brw.mes_id.month_year
            date_start = "%s-%s-01" %(year, month)
            date_end = "%s-%s-%s" %(year, month, calendar.monthrange(year, month)[1])
            date_end = datetime.strptime(date_end, '%Y-%m-%d') 
            formato = str(date_end).split(" ")
            date_end = formato[0]
        
        lista =[]
        titulo = []
        cabezera=[]
        
        if codigo:cabezera.append('codigo')
        if cedula: cabezera.append('cedula')
        if nombre:cabezera.append('nombre')
        if fecha_nacimiento:cabezera.append('fecha_nacimiento')
        if edad:cabezera.append('edad')
        if inicio_relacion_laboral:cabezera.append('inicio_relacion_laboral')
        if fin_relacion_laboral: cabezera.append('fin_relacion_laboral')
        if sueldo:cabezera.append('sueldo')
        if sede:cabezera.append('sede')
        if nomina:cabezera.append('nomina')
        if departamento:cabezera.append('departamento')
        if cargo:cabezera.append('cargo')
        if tiempo_servicio:
            cabezera.append('Años Antiguedad')
            cabezera.append('Meses Antiguedad')
            cabezera.append('Dias Antiguedad')
        if fecha_hoy_o_mes:cabezera.append('fecha')
        
        """consultado empleados"""
    
        obj_employee = self.pool.get('hr.employee') 

        if actual:
            date_end = self.get_final_date()
            
            if borrador:estados.append('borrador')
            if activo: estados.append('activo')
            if vacaciones:estados.append('vacaciones')
            if reposo:estados.append('reposo')
            if egresado:estados.append('egresado')

            if estados != []:  
                employee_id = obj_employee.search(cr, uid, [('state', 'in', estados)])
            else:
                employee_id = obj_employee.search(cr, uid, [])
        else:
           
            employee_id = obj_employee.search(cr, uid, [])

        if employee_id == []:
            raise osv.except_osv(_('ERROR!'), _('La combinacion de datos para dicha consulta no arrojo ningun resultado!!!'))
        
        browse_id = obj_employee.browse(cr, uid, employee_id)        
        
        for i in browse_id:
            carga=[]
            if i.start_rel_lab <= date_end:
                """ datos estandar que no varian segun el tiempo"""
                if codigo:carga.append(i.cod_number)
                if cedula: carga.append(i.identification_id)
                if nombre:carga.append(i.name)
                if fecha_nacimiento:carga.append(i.birthday)
                if edad:carga.append(i.edad)
                if inicio_relacion_laboral:carga.append(i.start_rel_lab)
                
                if fin_relacion_laboral: 

                    if i.state != "egresado":
                         carga.append(" ")
                    else:
                        fin_contrato = self.fin_relacion_laboral(i.id)
                        carga.append(fin_contrato)
               
                if actual:
                    
                    if sueldo:
                        s = ""
                        s = self._sueldo(i.id, date_end, sueldo)
                        carga.append(s)
                                          
                    if sede:
                        se = ""
                        se = self._sede(i.id, self.get_final_date(), sede)
                        carga.append(se)
                        
                    if nomina:carga.append(i.hr_payroll_id.name)
                    if departamento:carga.append(i.department_id.id)  
                    if cargo:carga.append(i.job_id.name)
                    
                    
                    if tiempo_servicio:
                     
                        if i.state != "egresado":
                            servicio = self.date_end_rel(self.get_final_date(), i.start_rel_lab, False)
                            timer = servicio.split('/')
                            carga.append(timer[0])
                            carga.append(timer[1])
                            carga.append(timer[2])
                        else:
                            query = """SELECT date_end 
                                   FROM hr_contract 
                                   WHERE employee_id = %s 
                                    ORDER BY id """
                            self.cr.execute(query %i.id)
                            contrato_id = self.cr.fetchall()
                            try:
                                date_end_contrat =  contrato_id[-1][0]
                                servicio = self.date_end_rel_egresados(i.start_rel_lab, date_end_contrat)
                                servicio.split('/')
                                timer = servicio.split('/')
                                if len(timer) < 3:
                                    carga.append(" ")
                                    carga.append(" ")
                                    carga.append(" ")
                                else:
                                    carga.append(timer[0])
                                    carga.append(timer[1])
                                    carga.append(timer[2])
                            except:
                                """si llega ocurrir un error en el tiempo"""
                                carga.append(" ")
                                carga.append(" ")
                                carga.append(" ")
                                
                    if fecha_hoy_o_mes:carga.append(self.get_final_date())
                    
                
                else:
                    """datos que varian segun el mes"""
                    if sueldo:
                        s = ""
                        s = self._sueldo(i.id, date_end, sueldo)
                        carga.append(s)
                        
                    if sede:
                        se = ""
                        se = self._sede(i.id, date_end, sede)
                        carga.append(se)
                        
                    if nomina:
                        n = ""
                        n = self._nomina(i.id, date_end, nomina)
                        carga.append(n)
                        
                    if departamento:
                        dp = ""
                        dp = self._departamento(i.id, date_end, departamento)
                        carga.append(dp)
                    
                    if cargo:
                        c = ""
                        c = self._cargo(i.id, date_end, cargo)
                        carga.append(c)
                        
                    if tiempo_servicio:
                        
                        if i.state != "egresado":
                            servicio = self.date_end_rel(date_end, i.start_rel_lab, False)
                            servicio.split('/')
                            timer = servicio.split('/')
                            carga.append(timer[0])
                            carga.append(timer[1])
                            carga.append(timer[2])
                        else:
                            query = """SELECT date_end 
                                   FROM hr_contract 
                                   WHERE employee_id = """+str(i.id)+""" 
                                    ORDER BY id """
                            self.cr.execute(query)
                            _contrato_ = self.cr.fetchall()
                            try:
                                fecha_f = _contrato_[-1][0]
                                servicio = self.date_end_rel_egresados(i.start_rel_lab, fecha_f)
                                servicio.split('/')
                                timer = servicio.split('/')
                                if len(timer) < 3:
                                    carga.append(" ")
                                    carga.append(" ")
                                    carga.append(" ")
                                else:
                                    carga.append(timer[0])
                                    carga.append(timer[1])
                                    carga.append(timer[2])
                            except:
                                """si llega ocurrir un error en el tiempo"""
                                carga.append(" ")
                                carga.append(" ")
                                carga.append(" ")
                            
                    if fecha_hoy_o_mes:carga.append(mes_id.name)
                lista.append(carga)
        titulo.append(cabezera)
        
        data={}
         
        if lista:
            data['form'] = lista
            data['title'] = titulo
        else:     
            raise osv.except_osv(_('ERROR!'), _('La combinacion de datos para dicha consulta no arrojo ningun resultado!!!'))
       
        return {
            'type': 'ir.actions.report.xml',
            'report_name':'general.trabajadores',
            'datas': data,
            }
            
    
    def fin_relacion_laboral(self, ids):
        if ids:
            query = """select date_end 
                        FROM hr_contract 
                        WHERE employee_id = %s
                        ORDER BY id """
            self.cr.execute(query %ids)
            fin_rel_lab = self.cr.fetchall()
            date_end =  fin_rel_lab[-1][0]
            if date_end:
                return date_end
            return ""
    
    def _sueldo(self, ids, date_stard, sueldo):
        if sueldo:
      
            query = """SELECT amount 
                   FROM hr_attribute 
                   WHERE employee_id = %s and date_start <= %s
                         and concept_id = 59 
                    ORDER BY id """
            self.cr.execute(query, (ids, date_stard))
            _salario = self.cr.fetchall()
            try:
                _salario = str(_salario[-1][-1])
                if _salario: 
                    return _salario
                return _salario
            except:
                return ""
    def _sede(self, ids, date_stard, sede):
        _sedes = ""
        if sede:
            query = """SELECT sede 
                   FROM hr_department_employee 
                   WHERE employee_id = %s and date_start <= %s
                    ORDER BY id """
            self.cr.execute(query, (ids, date_stard))
            _sede_ = self.cr.fetchall()
            try:
                _sedes = _sede_[-1][-1]
                if _sedes:
                    return _sedes
                return " "
            except:
                return ""
    def _nomina(self, ids, date_stard, nomina):
        payroll = ""
        if nomina:
            query = """SELECT payroll 
                   FROM hr_department_employee 
                   WHERE employee_id = %s and date_start <= %s
                    ORDER BY id """
            self.cr.execute(query, (ids, date_stard))
            _nomina_ = self.cr.fetchall()
            try:
                payroll = _nomina_[-1][0]
                if payroll:
                    return payroll
                return " "
            except:
                return ""
    
    def _cargo(self, ids, date_stard, cargo):
        if cargo:
            query = """SELECT job 
                   FROM hr_department_employee 
                   WHERE employee_id = %s and date_start <= %s
                    ORDER BY id """
            self.cr.execute(query, (ids, date_stard))
            _cargo_ = self.cr.fetchall()
            try:
                
                car = _cargo_[-1][-1]
                if car:
                    return car
                return " "
            except:
                return ""
        
    def _departamento(self, ids, date_stard, departamento ):
        
        if departamento:
              
            query = """SELECT department_id 
                   FROM hr_department_employee 
                   WHERE employee_id = %s and date_start <= %s
                    ORDER BY id """
            self.cr.execute(query, (ids, date_stard))
            _departamento_ = self.cr.fetchall()
            if _departamento_:
                res = _departamento_[-1][0].split("/")
                nombre = res[-1]
                query = """SELECT id 
                       FROM hr_department 
                       WHERE name = '"""+ nombre.strip() +"""'
                        ORDER BY id """
                self.cr.execute(query)                
                id_depart = self.cr.fetchall()
                if id_depart:
                    x = int(id_depart[-1][-1])
                    try:
                        return x
                    except:
                        return ""
                return ""
            return ""
            
    def get_final_date(self):
        return datetime.now().strftime('%Y-%m-%d')
    
    def elimina_tildes(self, s):
        return ''.join((c for c in unicodedata.normalize('NFD', unicode(s)) if unicodedata.category(c) != 'Mn'))
    
    def date_end_rel(self, fecha, date_start, date_end):
        date_start = datetime.strptime(date_start, '%Y-%m-%d')
        fin = datetime.strptime(fecha, '%Y-%m-%d') 
        if date_end:
            date_end = datetime.strptime(date_end, '%Y-%m-%d')
            res = self._tiempo_servicio(date_start, date_end)
        else:
            res = self._tiempo_servicio(date_start, fin)
        return str(res)
        
    def date_end_rel_egresados(self, date_start, date_end):
        if date_end == False:
            return " "
        else:
            date_start = datetime.strptime(date_start, '%Y-%m-%d')
            date_end = datetime.strptime(date_end, '%Y-%m-%d') 
            res = self._tiempo_servicio(date_start, date_end)
            return str(res)
        
    def cvr_date(self, fecha):
        if fecha:
            return  datetime.datetime.strptime(fecha, '%Y-%m-%d').strftime('%d%m%Y')                
        return False    
    
    def _tiempo_servicio(self, desde, hasta):
            res = ""
            if hasta.month == desde.month:
                if hasta.day < desde.day:
                    anos = hasta.year - desde.year - 1
                    meses = 12 - desde.month + hasta.month - 1
                    if hasta.month == 1:
                        dias = calendar.monthrange(hasta.year-1,12)[1] - \
                          desde.day + hasta.day
                    else:
                        dias = calendar.monthrange(hasta.year,hasta.month-1)[1] - \
                          desde.day + hasta.day 
                else: 
                    anos = hasta.year - desde.year
                    meses = desde.month - hasta.month
                    dias =  hasta.day - desde.day
                    
            elif hasta.month < desde.month:
                anos = hasta.year - desde.year - 1
                if hasta.day < desde.day:
                    meses = 12 - desde.month + hasta.month - 1
                    if hasta.month == 1:
                        dias = calendar.monthrange(hasta.year-1,12)[1] - \
                          desde.day + hasta.day
                    else:
                        dias = calendar.monthrange(hasta.year,hasta.month-1)[1] - \
                          desde.day + hasta.day 
                else:
                    meses = 12 - desde.month + hasta.month
                    dias =  hasta.day - desde.day  
            else:
                anos = hasta.year - desde.year
                meses = hasta.month - desde.month
                if hasta.day < desde.day:
                    meses = hasta.month - desde.month - 1
                    if hasta.month == 1:
                        dias = calendar.monthrange(hasta.year-1,12)[1] - \
                          desde.day + hasta.day
                    else:
                        dias = calendar.monthrange(hasta.year,hasta.month-1)[1] - \
                          desde.day + hasta.day
                else:
                    meses = hasta.month - desde.month
                    dias =  hasta.day - desde.day
            res = str(anos) + '/' + str(meses) + '/' + \
              str(dias) 
            return res
    
wizard_reporte_general()
