# /usr/bin/env python
# -*- coding: utf-8 -*-

import time
from osv import fields, osv

class wizard_ISLR(osv.osv_memory):
    
    _name ='wizard.ISLR'
    _columns = {
        'employee_ids': fields.many2many('hr.employee', 'payroll_emp_rel','payroll_id','emp_id', 'Employees', required=True),
        'date_from': fields.date('Desde', required=True),
        'date_to': fields.date('Hasta', required=True),
       }
    
    def print_report(self, cr, uid, ids, context=None):
        """
         To get the date and print the report
         @param self: The object pointer.
         @param cr: A database cursor
         @param uid: ID of the user currently logged in
         @param context: A standard dictionary
         @return: return report
        """
        if context is None:
            context = {}
        
        parameter_obj = self.pool.get('hr.parameters')
        param_conceptos_deven = parameter_obj.search(cr, uid, [('type', '=', 'conceptos_deven')])
        
        datas = {'ids': context.get('active_ids', [])}
        res = self.read(cr, uid, ids, ['employee_ids', 'date_from', 'date_to'], context=context)
        res = res and res[0] or {}
        datas['form'] = res
        datas['ids'] = res.get('employee_ids',[])
        param =  []
        for i in parameter_obj.browse(cr, uid, param_conceptos_deven):
            l = [n.id for n in i.concept_deven_ids]
            datas['form'].update({'param':str(l)})
                
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'wizard.islr',
            'datas': datas,
       }
      
   
wizard_ISLR()
