#!/usr/bin/env python
# -*- coding: utf-8 -*--

from osv import fields, osv
import calendar
from datetime import datetime 
import unicodedata
from tools.translate import _

class wizard_fondo_jubilacion(osv.osv_memory):
    _name = 'wizard.fondo.jubilacion'
    _description = 'Wizard para generar TXT para fondo de jubilacion'
    _columns = {
    'month_id': fields.many2one('hr.month', 'Mes', required=True), 
    }
    
    def generar_txt(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids)[0]
        month_id = brw.month_id.id 
        month = brw.month_id.month_year
        year = brw.month_id.hr_year_id.year 
        date_end = "%s-%s-%s" %(calendar.monthrange(year, month)[1], month, year)
        date_time = datetime.strptime(date_end, '%d-%m-%Y')
        date_end = date_time.strftime('%d%m%Y')
        obj_res_company = self.pool.get('res.company')
        obj_period = self.pool.get('hr.period')
        obj_process = self.pool.get('hr.process') 
        obj_payslip_line = self.pool.get('hr.payslip.line')  
        obj_concept = self.pool.get('hr.concept')  
        obj_payroll = self.pool.get('hr.payroll')  
        parameter_obj = self.pool.get('hr.parameters')
        
        res_company_id = obj_res_company.search(cr, uid, [])
        res_company_brw = obj_res_company.browse(cr, uid, res_company_id)[0]
        cod_jubilacion = res_company_brw.cod_patronal_seguridad_soc
        
        if not cod_jubilacion:
            raise osv.except_osv(_('ERROR!'), _('No se ha definido el codigo de Jubilacion y Pension'))
        
        
        parameter_concept_jubilacion_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_jubilacion')])
        parameter_concept_aporte_compania_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_aporte_compania')])
        
        if not parameter_concept_jubilacion_id:
           raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para la retencion de fondo de Jubilacion y Pension'))
        
        if not parameter_concept_aporte_compania_id:
           raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido para el aporte compania para Fondo de Pensiones y Jubilaciones'))
        
            
        parameter_concept_jubilacion_brw = parameter_obj.browse(cr, uid, parameter_concept_jubilacion_id)[0]
        parameter_concept_aporte_compania_brw = parameter_obj.browse(cr, uid, parameter_concept_aporte_compania_id)[0]
        valor = parameter_concept_jubilacion_brw.value 
        concept_id = []
        concept_id.append(parameter_concept_jubilacion_brw.concept_jubilacion_id.id)
        concept_id.append(parameter_concept_aporte_compania_brw.concept_aporte_compania_id.id) 
        period_id = obj_period.search(cr, uid, [('hr_month_id', '=', month_id), ('state', '=', 'close')])
        process_id = obj_process.search(cr, uid, [('hr_period_ids', 'in', period_id)])
        payroll_id = obj_payroll.search(cr, uid, [])
        for i in payroll_id:
            otros_procesos_id = obj_process.search(cr, uid, [('hr_payroll_ids', '=', i), 
              ('type', 'not in', ('prestaciones','bono_alimentacion','guarderias')), 
              ('hr_period_ids', 'in', period_id), ('state', '=', 'done')])
            if otros_procesos_id:
                proceso_id = obj_process.search(cr, uid, [('hr_payroll_ids', '=', i), ('type', '=', 'prestaciones'), 
                  ('hr_period_ids', 'in', period_id), ('state', '=', 'done')])
                if not proceso_id:
                   name = obj_payroll.browse(cr, uid, i).name  
                   raise osv.except_osv(_('ERROR!'), _('La %s para el mes de %s no \
                     posee proceso de Prestaciones Sociales aprobado'%(name, brw.month_id.name)))
       
        payslip_line_id = obj_payslip_line.search(cr, uid, [('process_id','in', process_id), ('concept_id', 'in', concept_id)])
        process_brw = obj_process.browse(cr,uid, process_id)

        if not payslip_line_id:
           raise osv.except_osv(_('ERROR!'), _('Txt vacio o mal formado'))

            
        payslip_line_brw = obj_payslip_line.browse(cr,uid, payslip_line_id)
        concepto = self.concepto
        remuneracion_base = self.remuneracion_base
        salida = [(i.employee_id.identification_id, date_end, i.employee_id.first_name, i.employee_id.second_name, i.employee_id.first_surname, i.employee_id.second_surname, cod_jubilacion, remuneracion_base(concepto(i, concept_id[0]), valor), concepto(i, concept_id[0]), concepto(i, concept_id[1])) for i in payslip_line_brw if i.total != 0.00]
        salida.sort()
        acum = {}
        
        for i in  salida:
            acum[i[0:7]] = [[00.0],[00.0], [00.0]] 
        
        for i in salida:
            if  i[0:7] in acum:
                acum[i[0:7]][0].append(i[7])  
                acum[i[0:7]][1].append(i[8])  
                acum[i[0:7]][2].append(i[9])
        
        nombre_txt = 'O' + date_end[0:4] + date_end[6:] + '0' 
        ir_obj = self.pool.get('ir.actions.report.xml')
        ir_id = ir_obj.search(cr, 1, [('model','=',self._name)]) 
        ir_write= ir_obj.write(cr, 1, ir_id, {'name':nombre_txt})
        
        data = {'form':{'salida':[]}} 
        elimina_tildes =  self.elimina_tildes
        cvr_total = self.cvr_total
        create_name = self.create_name
        suma = self.suma
        
        for n in acum:
            nombre = create_name(n[2], n[3], n[4], n[5])
            remuneracion = cvr_total(suma(acum[n][0]))
            retencion = cvr_total(suma(acum[n][1]))
            aporte = cvr_total(suma(acum[n][2]))
            
            data['form']['salida'].append({'cedula':n[0], 'fecha':n[1], 'nombre':nombre, 'codigo': n[6], 'remuneracion':remuneracion, 'retencion':retencion, 'aporte':aporte})     
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'txt.jubilacion.pension',
            'datas': data,
            }     
    
    def suma(self, lista):
        c = 0
        for i in lista:
            if i != None:
               c = c + i 
        return round(c, 2)
                    
    def remuneracion_base(self, cant, criterio):
        if cant != None:
           criterio = criterio * 100
           num = cant * 100 / criterio 
           return round(num, 2)  
    
    def create_name(self, first_name, second_name, first_surname, second_surname):
        elimina_tildes =  self.elimina_tildes
        name = ''
        if  first_name:
            first_name =  elimina_tildes(first_name).upper()
            name = first_name
        if second_name:
           second_name =  elimina_tildes(second_name)[0].upper()
           name = name + ' %s.' % second_name
        if first_surname:
           first_surname =  elimina_tildes(first_surname).upper()
           name = name + ' %s' % first_surname
        if second_surname:
           second_surname  = elimina_tildes(second_surname)[0].upper() 
           name = name + ' %s.' % second_surname
        return name 
           
              
      
    def cvr_str(self, string):

        if string:
           string = self.elimina_tildes(string)
        
        if string:
           string = string[0]     
            
        return '' if not  string else string
    
    def elimina_tildes(self, s):
        return ''.join((c for c in unicodedata.normalize('NFD', unicode(s)) if unicodedata.category(c) != 'Mn'))   
    
    def cvr_total(self, qty):
        if qty:
           qty = str(round(qty, 2))
           qty = qty.split('.')
           if len(qty[1]) < 2:
              qty = qty[0] + ',' + qty[1] + '0'
              return qty 
           else:
              return qty[0] + ',' + qty[1]
        return False          
    
    def concepto(self, iter, concept):
        if iter.concept_id.id == concept:
           return round(iter.total, 2) 
        
           
    
        
            
            
           

    
wizard_fondo_jubilacion()
