#!/usr/bin/env python
# -*- coding: utf-8 -*--

import datetime
from datetime import datetime
from dateutil import relativedelta
import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import logging
import base64
import os
import math
import calendar
import re 
import unicodedata


class wizard_generador_txt_sso(osv.osv_memory):
    _name = 'wizard.generador.txt.sso'
    _description = 'Wizar para generar TXT para sistema sso'
    _columns = {
    
    'concept_id': fields.many2one('hr.concept', 'Concepto', required=True),
    'month_id': fields.many2one('hr.month', 'Mes', required=True), 
    'sede_id': fields.many2one('hr.sede', 'Sede', required=True), 
    'payroll_id': fields.many2one('hr.payroll', 'Nómina', required=True),
    'all_sede': fields.boolean('Para todas las sedes'),
    'all_nomina': fields.boolean('Para todas las nominas'),
    
    }
    _defaults = {
        'all_sede': True, 'all_nomina':True, 
    }
    def generar_txt_sso(self, cr, uid, ids, context=None):
        
        self.uid = uid
        self.cr = cr
        brw = self.browse(cr, uid, ids)[0]
        year = brw.month_id.hr_year_id.year 
        month =  brw.month_id.month_year
        date_startt = "%s-%s-01" %(year, month)
        date_endd = "%s-%s-%s" %(year, month, calendar.monthrange(year, month)[1]) 
        
        fechastart = datetime.strptime(date_startt, '%Y-%m-%d')
        fechaend = datetime.strptime(date_endd,  '%Y-%m-%d')
        
        date_startt = fechastart.strftime('%Y-%m-%d')
        date_endd = fechaend.strftime('%Y-%m-%d')
        
        
        obj_attribute = self.pool.get('hr.attribute') 
        parameter_obj = self.pool.get('hr.parameters')
        
        month_id = [brw.month_id.id]
        sede_id = [brw.sede_id.id]
        payroll_id = [brw.payroll_id.id]
        
        all_sede = brw.all_sede
        all_nomina = brw.all_nomina
        
        parametro_id = parameter_obj.search(cr, uid, [('type', '=', 'concepto_sueldo'),('payroll_id', '=', None)])
        
        if not parametro_id:
            raise osv.except_osv(_('ERROR!'), _('No hay un parametro definido'))
        
        concept_id= parameter_obj.browse(cr, uid, parametro_id)[0].concept_wage_id.id
        
        if all_sede:
            sede_id = self.pool.get('hr.sede').search(cr, uid, [])
            
        if all_nomina:
            payroll_id =  self.pool.get('hr.payroll').search(cr, uid, [])
            
        obj_employee = self.pool.get('hr.employee')
        employee_id = obj_employee.search(cr, uid, [('hr_sede_id','in', sede_id),('hr_payroll_id', 'in', payroll_id)])
        
        hr_attribute_id_s = obj_attribute.search(cr, uid, [('employee_id', 'in', employee_id), ('concept_id', '=', concept_id), ('date_start','>=',date_startt), ('date_start','<=',date_endd),'|',('active','=', True),('active','=',False)])
        hr_attribute_id_e = obj_attribute.search(cr, uid, [('employee_id', 'in', employee_id), ('concept_id', '=', concept_id), ('date_end','>=',date_startt), ('date_end','<=',date_endd),'|',('active','=', True),('active','=',False)])
        
 
        if not hr_attribute_id_s:
                raise osv.except_osv('ERROR', 'No existen variaciones salariales para la consulta que usted ha realizado - Txt vacio o mal formado')
        if not hr_attribute_id_e:
                raise osv.except_osv('ERROR', 'No existen variaciones salariales para la consulta que usted ha realizado - Txt vacio o mal formado')
        
        hr_p = hr_attribute_id_s + hr_attribute_id_e 
        hr_attribute_brw = obj_attribute.browse(cr ,uid, hr_p)
        
        salida = [(i.employee_id.id, 'V', self.cedula(i.employee_id.identification_id), self.elimina_tildes(i.employee_id.name), self.cvr_date(str(i.date_start)), self.cvr_date(str(i.date_end)), i.amount) for i in hr_attribute_brw]
        salida.sort()
        
        acum = {}
        
        for i in salida:
                acum[i[0:4]] = {'date_start':[], 'date_end':[], 'monto':[]}
           
        for i in salida:
            if i[0:4] in acum:
                acum[i[0:4]]['date_start'].append(i[4])
                acum[i[0:4]]['date_end'].append(i[5])
                acum[i[0:4]]['monto'].append(i[6])
        for i in acum:
            acum[i]['monto'].sort()
            acum[i]['date_start'].sort()
            acum[i]['date_end'].sort() 
        
        for i in acum:
            c = 0
            for m in acum[i]['monto']:
                m = str(m).split('.')
                if len(m[0]) <= 3:
                    m = m[0]+"."+m[1]
                    monto = (float(m)*7)
                else:
                    m = m[0]+"."+m[1]
                    monto = ((float(m)*12)/52)
                acum[i]['monto'][c] = monto
                c = c+ 1
        data = {'form':acum}
    
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'txt.sso',
            'datas': data,
            }

    def cedula(self, cedula):
        
        digitos = 9
        num = len(cedula)

        total = digitos - num
        l = []
        if total > 0:
            for i in range(total):
                cedula = "0" + cedula
       
        return cedula

    
    def calculossssss(self, employee_id, date_startt, date_endd):
    
        departmet_ = self.pool.get('hr.department.employee')
        searh = departmet_.search(self.cr, self.uid, [('employee_id', '=', employee_id)])
        lista_pay = []
        for x in searh:
            brw = departmet_.browse(self.cr ,self.uid, x)
            lista_pay.append(brw.id_payroll)
        lista_ = set(lista_pay)
        lista_pay = list(lista_)
        if len(lista_pay) < 2:
                payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, lista_pay[0])
                return payroll_brw.code
        else:
                return False

    def calculo3(self, employee_id, date_start, date_end, monto):
        
            departmet_ = self.pool.get('hr.department.employee')
            searh = departmet_.search(self.cr, self.uid, [('employee_id','=', employee_id),('date_end','>=',date_end),('date_start','<=',date_start)])
            
            if searh:
                brw = departmet_.browse(self.cr ,self.uid, searh)
                if brw: 
                    payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, brw[0].id_payroll)
                
                    if payroll_brw.code == 'ND':
                        monto = (monto*7)
                    else:
                        monto = ((monto*12)/52)
                    
                    m = str(round(monto, 2)).split('.')
                    
                    if len(m[1]) <= 1:
                        m = str(m[0])
                       
                        return m
                    else:
                      
                        return round(monto, 2)
            else:
                    monto = ((monto*12)/52)
                    
                    m = str(round(monto, 2)).split('.')
                    
                    if len(m[1]) <= 1:
                        m = str(m[0])
                       
                        return m
                    else:
                      
                        return round(monto, 2)
                        
    def calculo(self, employee_id, date_start, date_end, monto):
            departmet_ = self.pool.get('hr.department.employee')
            searh = departmet_.search(self.cr, self.uid, [('employee_id', '=', employee_id),('date_start','<=',date_start), ('date_end','>=',date_end)])
            if searh:
                brw = departmet_.browse(self.cr ,self.uid, searh)
                if brw: 
                    payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, brw[0].id_payroll)
                    if payroll_brw.code == 'ND':
                        monto = (monto*7)
                    else:
                        monto = ((monto*12)/52)
                    m = str(round(monto, 2)).split('.')
                    if len(m[1]) <= 1:
                        m = str(m[0])
                        return m
                    else:
                        return round(monto, 2)
            else:
                searh = departmet_.search(self.cr, self.uid, [('employee_id', '=', employee_id),'|',('date_start','<=',date_start)])
                if searh:
                    brw = departmet_.browse(self.cr ,self.uid, searh)
                    if brw: 
                        payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, brw[0].id_payroll)
                        if payroll_brw.code == 'ND':
                            monto = (monto*7)
                        else:
                            monto = ((monto*12)/52)
                        m = str(round(monto, 2)).split('.')
                        
                        if len(m[1]) <= 1:
                            m = str(m[0])
                            return m
                        else:
                            return round(monto, 2)
            
    def calculo2(self, employee_id, date_start, monto):
    
            departmet_ = self.pool.get('hr.department.employee')
            searh = departmet_.search(self.cr, self.uid, [('employee_id', '=', employee_id),('date_start','<=',date_start),('date_end','=',False)])
            
            if searh:
                brw = departmet_.browse(self.cr ,self.uid, searh)
                
                if brw: 
                    payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, brw[0].id_payroll)
            
                    if payroll_brw.code == 'ND':
                        monto = (monto*7)
                    else:
                        monto = ((monto*12)/52)
                    
                    m = str(round(monto, 2)).split('.')
                    
                    if len(m[1]) <= 1:
                        m = str(m[0])
                        
                        return m
                    else:
                        
                        return round(monto, 2)
            
            else:
                
                searh = departmet_.search(self.cr, self.uid, [('employee_id', '=', employee_id),'|',('date_start','<=',date_start),('date_start','>=',date_start)])
            
                if searh:
                    
                    brw = departmet_.browse(self.cr ,self.uid, searh)
                    
                    if brw: 
                        payroll_brw = self.pool.get('hr.payroll').browse(self.cr, self.uid, brw[0].id_payroll)
                    
                        if payroll_brw.code == 'ND':
                            monto = (monto*7)
                        else:
                            monto = ((monto*12)/52)
                        
                        m = str(round(monto, 2)).split('.')
                        
                        if len(m[1]) <= 1:
                            m = str(m[0])
                           
                            return m
                        else:
                           
                            return round(monto, 2)
            
    def elimina_tildes(self, s):
        return ''.join((c for c in unicodedata.normalize('NFD', unicode(s)) if unicodedata.category(c) != 'Mn'))
    
    def cvr_date(self, fecha):
        if fecha != 'False':
            fechas =  datetime.strptime(fecha, '%Y-%m-%d').strftime('%d/%m/%Y') 
            return fechas         
        
        return False    
    
    def cvr_total(self, qty):
        if qty:
           qty = str(round(qty, 2))
           qty = qty.split('.')
           if len(qty[1]) < 2:
              qty = qty[0] + qty[1] + '0'
              return qty 
           else:
              return qty[0]+qty[1]
        return False    
        
    def cvr_fechas(self, fecha):
        fechastart = datetime.strptime(fecha, '%Y-%m-%d')
        return fechastart

wizard_generador_txt_sso()
