#!/usr/bin/env python
# -*- coding: utf-8 -*-

from osv import fields, osv
import datetime
from datetime import timedelta
import time  



class hr_account_wizard(osv.osv_memory):
    _name = 'hr.account.wizard'
    _description = 'wizard para hr_account'
    _columns = {
        'name':fields.char('Name', size=256),
        'concept_id': fields.many2one('hr.concept', 'Concepto', required=True),
        'analytic_account_id': fields.many2one('account.analytic.account', 'Cuenta analítica', required=True),
        'payroll_id': fields.many2one('hr.payroll', 'Nómina', required=True),
        'account_id': fields.many2one('account.account', 'Cuenta contable', required=True),
        'account_payroll_id': fields.many2one('account.account', 'Cuenta contrapartida', required=True),
        'partida_presupuesto': fields.many2one('clasificador.presupuestario','Partida Presupuestaria', required=True),
        'all_concept_id': fields.boolean('Para todos los conceptos'),
        'all_analytic_account_id': fields.boolean('Para todas las Cuentas analíticas'),
        'all_payroll_id': fields.boolean('Para todas las Nominas'),
    }

    
    def create_hr_account(self, cr, uid, ids, context=None):
        obj = self.pool.get('hr.account')
        brw = self.browse(cr, uid, ids)[0]
        concept_id = brw.concept_id.id
        analytic_account_id = brw.analytic_account_id.id
        payroll_id = brw.payroll_id.id
        partida_presupuesto = brw.partida_presupuesto.id
        account_id = brw.account_id.id
        account_payroll_id = brw.account_payroll_id.id
        
        salida = {'type': 'ir.actions.act_window_close', 'active_id': ids}
        crd = {'analytic_account_id': analytic_account_id, 'partida_presupuesto': partida_presupuesto, 'account_id': account_id, 'payroll_id': payroll_id,'concept_id': concept_id,'account_payroll_id': account_payroll_id}
        args_write = {'account_payroll_id': account_payroll_id, 'account_id': account_id, 'partida_presupuesto': partida_presupuesto}
        
        all_concept_id = brw.all_concept_id
        all_analytic_account_id = brw.all_analytic_account_id 
        all_payroll_id = brw.all_payroll_id
        
        # si esta activada esta opcion se buscan todos los ids de hr.concept
        if all_concept_id:
           concept_id = self.pool.get('hr.concept').search(cr, uid, [])
        
        # si esta activada esta opcion se buscan todos los ids de account.analytic.account
        if all_analytic_account_id :
           analytic_account_id = self.pool.get('account.analytic.account').search(cr, uid, [])
        
        # si esta activada esta opcion se buscan todos los ids de hr.payroll
        if all_payroll_id:
           payroll_id =  self.pool.get('hr.payroll').search(cr, uid, [])
            
        # solo para todos los conceptos            
        if all_concept_id and not all_analytic_account_id and not all_payroll_id:
           obj_id = obj.search(cr, uid, [('concept_id', 'in', concept_id),  ('analytic_account_id', '=', analytic_account_id,),('payroll_id', '=', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_concept_id_busy = list(set([n.concept_id.id for n in obj_brw]))
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write)

           if concept_id:
              concept_id = [i for i in concept_id if i not in ids_concept_id_busy]           
              for i in concept_id:
                  crd['concept_id'] = i
                  obj.create(cr, uid, crd)
           return salida     
        # solo para todos las Cuenta analiticas        
        elif all_analytic_account_id and not all_concept_id and not all_payroll_id :
           obj_id = obj.search(cr, uid, [('concept_id', '=', concept_id),  ('analytic_account_id', 'in', analytic_account_id,),('payroll_id', '=', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = [n.id for n in obj_brw]
           ids_analytic_account_id_busy = [n.analytic_account_id.id for n in obj_brw]
           analytic_account_id = list(set([i for i in analytic_account_id if i not in ids_analytic_account_id_busy]))
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write)        
           
           if analytic_account_id:
              for n in analytic_account_id:
                  crd['analytic_account_id'] = n
                  obj.create(cr, uid, crd)
           return salida  
       
        # solo para todos las Nominas  
        elif all_payroll_id and not all_concept_id and not all_analytic_account_id:
           obj_id = obj.search(cr, uid, [('concept_id', '=', concept_id),  ('analytic_account_id', '=', analytic_account_id,),('payroll_id', 'in', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_payroll_id_busy = list(set([n.payroll_id.id for n in obj_brw]))
           payroll_id = [i for i in payroll_id if i not in ids_payroll_id_busy]
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write)
            
           if  payroll_id: 
               for c in payroll_id:
                   crd['payroll_id'] = c
                   obj.create(cr, uid, crd)
                   
           return salida  
        
        # Si es para todos los conceptos y nominas 
        elif all_concept_id and  all_analytic_account_id and not all_payroll_id:
           obj_id = obj.search(cr, uid, [('concept_id', 'in', concept_id),  ('analytic_account_id', 'in', analytic_account_id,),('payroll_id', '=', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_concept_id_busy = [n.concept_id.id for n in obj_brw]
           ids_analytic_account_id_busy = [n.analytic_account_id.id for n in obj_brw]
           concept_id = [i for i in concept_id if i not in ids_concept_id_busy]
           analytic_account_id = [i for i in analytic_account_id if i not in ids_analytic_account_id_busy]
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write)
           
           for x in concept_id:
                for y in analytic_account_id:
                    crd['concept_id'] = x
                    crd['analytic_account_id'] = y
                    obj.create(cr, uid, crd)
           return salida
        
        # Si es para todos los conceptos y Cuentas analiticas 
        elif all_concept_id and  all_payroll_id and not all_analytic_account_id:
           obj_id = obj.search(cr, uid, [('concept_id', 'in', concept_id),  ('analytic_account_id', '=', analytic_account_id,),('payroll_id', 'in', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_concept_id_busy = list(set([n.concept_id.id for n in obj_brw]))
           ids_payroll_id_busy = list(set([n.payroll_id.id for n in obj_brw]))
           concept_id = [i for i in concept_id if i not in ids_concept_id_busy]
           payroll_id = [i for i in payroll_id if i not in ids_payroll_id_busy]
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write) 
           
           for x in concept_id:
                for y in payroll_id:
                    crd['concept_id'] = x
                    crd['payroll_id'] = y
                    obj.create(cr, uid, crd)
           return salida
        
        # si es para todas las nominas y Cuentas analiticas 
        elif all_payroll_id and all_analytic_account_id and not all_concept_id:
           obj_id = obj.search(cr, uid, [('concept_id', '=', concept_id),  ('analytic_account_id', 'in', analytic_account_id,),('payroll_id', 'in', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_analytic_account_id_busy = [n.analytic_account_id.id for n in obj_brw]
           ids_payroll_id_busy = [n.payroll_id.id for n in obj_brw]
           analytic_account_id = [i for i in analytic_account_id if i not in ids_analytic_account_id_busy]
           payroll_id = [i for i in payroll_id if i not in ids_payroll_id_busy]
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write) 
           
           for x in payroll_id:
                 for y in analytic_account_id:
                    crd['payroll_id'] = x
                    crd['analytic_account_id'] = y
                    obj.create(cr, uid, crd)
           return salida
        
        # si es seleccionada toas las nominas, conceptos y cuentas analiticas
        elif all_payroll_id and all_analytic_account_id and all_concept_id:
           obj_id = obj.search(cr, uid, [('concept_id', 'in', concept_id),  ('analytic_account_id', 'in', analytic_account_id,),('payroll_id', 'in', payroll_id)])
           obj_brw = obj.browse(cr, uid, obj_id)
           ids_busy = list(set([n.id for n in obj_brw]))
           ids_analytic_account_id_busy = [n.analytic_account_id.id for n in obj_brw]
           ids_payroll_id_busy = list(set([n.payroll_id.id for n in obj_brw]))
           ids_concept_id_busy = list(set([n.concept_id.id for n in obj_brw]))
           analytic_account_id = list(set([i for i in analytic_account_id if i not in ids_analytic_account_id_busy]))
           payroll_id = [i for i in payroll_id if i not in ids_payroll_id_busy]
           concept_id = [i for i in concept_id if i not in ids_concept_id_busy]
           
           if ids_busy:
              obj.write(cr, uid, ids_busy, args_write) 
           
           for x in concept_id:
                 for y in analytic_account_id:
                     for z in payroll_id:
                        crd['concept_id'] = x
                        crd['analytic_account_id'] = y
                        crd['payroll_id'] = z
                        obj.create(cr, uid, crd)
           return salida
            
        return salida 
        
hr_account_wizard()
