#!/usr/bin/env python
# -*- coding: utf-8 -*--

from time import strftime
from datetime import *
import datetime
from datetime import date
from datetime import datetime, timedelta
from datetime import datetime
import datetime as dt
from dateutil import relativedelta  
import netsvc
from osv import fields, osv
import tools
from tools.translate import _
import logging
import base64
import os
import math
import calendar
import re 
import unicodedata

class wizard_report_aniversarios(osv.osv_memory):
    _name = "wizard.report.aniversarios"
    _description = 'Wizard para generar REPORTE de Aniversarios'
    
    
    _columns = {

        'fecha_desde': fields.date('Fecha Desde' , required=True),
        'fecha_hasta': fields.date('Fecha Hasta', required=True),
        'formato':fields.selection([('nacimiento','Nacimiento'),('aniversario', 'Aniversario'), ('ambos', 'Nacimiento y aniversario')], '', required=True),
     }
    
    def generar_reporte_aniversarios(self, cr, uid, ids, context=None):
        brw = self.browse(cr, uid, ids)[0]
        fecha_desde = brw.fecha_desde
        fecha_hasta = brw.fecha_hasta
        formato = brw.formato
        
        if fecha_desde:fecha_desde = datetime.strptime(fecha_desde, '%Y-%m-%d')
        if fecha_hasta:fecha_hasta = datetime.strptime(fecha_hasta, '%Y-%m-%d')
        if fecha_hasta < fecha_desde:raise osv.except_osv(_('ERROR!'), _('ERROR EN LA COMBINACION DE FECHAS!!!'))
        if fecha_hasta.year != fecha_desde.year:raise osv.except_osv(_('ERROR!'), _('LAS FECHAS DEBEN ESTAR EN EL MISMO AÑO!!!'))
        
        obj_employee = self.pool.get('hr.employee')
        employee_id = obj_employee.search(cr, uid, [('state','not in',['egresado','borrador'])])
        browse_id = obj_employee.browse(cr, uid, employee_id)
        
        acum_mes = {}
        meses = {1:'ENERO',2:'FEBRERO',3:'MARZO',4:'ABRIL',5:'MAYO',6:'JUNIO',7:'JULIO',8:'AGOSTO',9:'SEPTIEMBRE',10:'OCTUBRE',11:'NOVIEMBRE',12:'DICIEMBRE'}
        
        for i in browse_id:
            birthday = datetime.strptime(i.birthday, '%Y-%m-%d')
            new_bir = i.birthday.split('-')
            new_bir[0] = fecha_hasta.year 
            
            bir = ""
            for z in new_bir:
                if bir == "":bir = str(z) 
                else:bir = bir + "-" + str(z)
            new_bir = datetime.strptime(bir,'%Y-%m-%d')
            
            if len(str(new_bir.day)) == 1:dia = "0" + str(new_bir.day)
            else:dia = str(new_bir.day)
            
            if len(str(new_bir.month)) == 1:mes = "0" + str(new_bir.month)
            else:mes = str(new_bir.month)
 
            if formato == 'nacimiento':
                if new_bir >= fecha_desde and new_bir <= fecha_hasta:
                    if new_bir.month in acum_mes:acum_mes[new_bir.month] += [{'employee':i.name, 'fecha_nac': dia + "/" + mes}]
                    else:acum_mes[new_bir.month] = [{'employee':i.name, 'fecha_nac': dia +"/"+ mes}]
            
            start_rel_lab = datetime.strptime(i.start_rel_lab, '%Y-%m-%d')
            new_aniv = i.start_rel_lab.split('-')
            new_aniv[0] = fecha_hasta.year 
            
            aniver = ""
            for z in new_aniv:
                if aniver == "":aniver = str(z) 
                else:aniver = aniver + "-" + str(z)
            new_aniv = datetime.strptime(aniver,'%Y-%m-%d')
            
            if formato == 'aniversario':
                if new_aniv >= fecha_desde and new_aniv <= fecha_hasta:
                    res =  int(fecha_hasta.year) - int(start_rel_lab.year)
                    fe = i.start_rel_lab.split('-')
                    if start_rel_lab.month in acum_mes:acum_mes[start_rel_lab.month] += [{'employee':i.name, 'fecha_ingreso': i.start_rel_lab, 'servicio': str(res), 'ord': fe[2] +"/"+fe[1]}]
                    else:acum_mes[start_rel_lab.month] = [{'employee':i.name, 'fecha_ingreso': i.start_rel_lab, 'servicio': str(res), 'ord': fe[2] +"/"+fe[1]}]
        
        
            if formato == 'ambos':
                if new_aniv >= fecha_desde and new_aniv <= fecha_hasta:
                    res =  int(fecha_hasta.year) - int(start_rel_lab.year)
                    fe = i.start_rel_lab.split('-')
                    if start_rel_lab.month in acum_mes:acum_mes[start_rel_lab.month] += [{'employee':i.name, 'fecha_ingreso': i.start_rel_lab, 'servicio': str(res), 'ord': fe[2] +"/"+fe[1]}]
                    else:acum_mes[start_rel_lab.month] = [{'employee':i.name, 'fecha_ingreso': i.start_rel_lab, 'servicio': str(res), 'ord': fe[2] +"/"+fe[1]}]
                    
                if new_bir >= fecha_desde and new_bir <= fecha_hasta:
                    if new_bir.month in acum_mes:acum_mes[new_bir.month] += [{'employee':i.name, 'fecha_nac': dia + "/" + mes}]
                    else:acum_mes[new_bir.month] = [{'employee':i.name, 'fecha_nac': dia +"/"+ mes}]
        
        data={}
        
        if formato == 'ambos':
            for i in acum_mes:
                lista_ordenada = []
                for x in acum_mes[i]:
                    lista_ordenada.append(x)
                lista_ordenada.sort(key=lambda x: x['employee'])
                acum_mes[i] = lista_ordenada
      
        if formato == 'nacimiento':
                for i in acum_mes:
                    lista_ordenada = []
                    for x in acum_mes[i]:
                        lista_ordenada.append(x)
                    lista_ordenada.sort(key=lambda x: x['fecha_nac'])
                    acum_mes[i] = lista_ordenada
        
        if formato == 'aniversario':
                for i in acum_mes:
                    lista_ordenada = []
                    for x in acum_mes[i]:
                        lista_ordenada.append(x)
                    lista_ordenada.sort(key=lambda x: x['ord'])
                    acum_mes[i] = lista_ordenada
        
        order_list = []
        for x in sorted(acum_mes.iterkeys()):
            order_list.append({x:acum_mes[x]})
        
        
        #############  titulo  ########################
        
        if fecha_hasta.month == fecha_desde.month:mon =  str(meses[fecha_hasta.month]) + "-" + str(fecha_hasta.year)
        else:mon = "Desde " + meses[fecha_desde.month] + "-" + str(fecha_desde.year) + " hasta " + meses[fecha_hasta.month] + "-" + str(fecha_hasta.year)
        if formato == 'ambos':titulo = "Antiguedad (años) y cumpleaños, " + mon
        if formato == 'nacimiento':titulo = "Cumpleaños, " + mon 
        if formato == 'aniversario':titulo = "Antiguedad (años), " + mon
        
        
        if order_list:
            data['form'] = order_list
            data['titulo'] = titulo
            data['dat'] = formato
        else:
            raise osv.except_osv(_('ERROR!'), _('NO EXISTEN DATOS DISPONIBLES PARA GERERAR ESTE REPORTE!!!'))
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'sisb.aniversario',
            'datas':data, 
            }

wizard_report_aniversarios()
