#!/usr/bin/python
# -*- encoding: utf-8 -*-

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt

from osv import osv,fields
from tools.translate import _
import unicodedata
import re
import datetime

class cartera_cliente(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(cartera_cliente, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'datos_cliente': self.datos_cliente,
            'equipo_ventas': self.equipo_ventas,
            'vendedor_': self.vendedor_,
            'pais_': self.pais_,
            'limpiar': self.limpiar,
            
            
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
    
    
    def datos_cliente(self, partner_id):
        datos=[]

        if partner_id:
            query_partner = """ select 
                p.date,
                p.name,
                p.vat,
                p.wh_iva_agent,
                p.ref,
                p.user_id,
                p.section_id,
                phone,
                street,
                country_id,
                city,
                p.public_partner,
                p.credit_limit
            from res_partner p, res_partner_address d where
                p.id = d.partner_id and p.id = %s order by p.id """
            self.cr.execute(query_partner %partner_id)
            datos = self.cr.fetchall()
            return datos
        
    def equipo_ventas(self, id_equipo):
        if id_equipo:
            query_equipo = """select complete_name from crm_case_section
                            where id = %s order by id """
            self.cr.execute(query_equipo %id_equipo)
            equipo = self.cr.fetchall()
            return equipo[0][0]
        return ""
    
    def vendedor_(self, id_vendedor):
        if id_vendedor:
            query_equipo = """select name from res_users
                           where id =  %s order by id """
            self.cr.execute(query_equipo %id_vendedor)
            vendedor = self.cr.fetchall()
            return vendedor[0][0]
        return ""
    
    def pais_(self, id_pais):
        if id_pais:
            query_equipo = """select name from res_country
                           where id =  %s order by id """
            self.cr.execute(query_equipo %id_pais)
            pais = self.cr.fetchall()
            return pais[0][0]
        return ""
        
    def limpiar(self, limite, res):
        if not limite:
            return ""
        else:
            return res
    

report_sxw.report_sxw('report.cartera.cliente.xml',
    'wizard.cartera.cliente',
    'sisb_reportes_especiales/report/cartera_cliente.rml',
    parser=cartera_cliente)
