# /usr/bin/env python
# -*- encoding: utf-8 -*-

from osv import osv
from osv import fields
import datetime
from tools.translate import _

class wizard_analisis_inventario(osv.osv_memory):
    
    _name = "wizard.analisis.inventario"
    _description = "wizard para generar reporte de analisis de inventario"
    
    _columns = {
    'is_periodo': fields.boolean('Periodo'),
    'fecha_desde': fields.date('Fecha desde'),
    'fecha_hasta': fields.date('Fecha Hasta'),
    'period_id': fields.many2one('account.period', 'Periodo'),
    'location_id': fields.many2one('stock.location', 'Ubicacion', required=True),
    'product_id': fields.many2one('product.product', 'Producto'),
    'all_product': fields.boolean('Todos los Productos'),
    'formato':fields.selection([('detail','Detallado'),('resume', 'Resumido'), ('total', 'Total')], 'Formato', required=True),
     }
    _defaults = {
        'all_product':True,
    }
    

    def generate_report(self, cr, uid, ids, context=None):
        agrupador = {}
        wizard_brw = self.browse(cr, uid, ids)[0]
        for i in self._columns:
            if type(getattr(wizard_brw, i)) in [osv.orm.browse_record, osv.orm.browse_null]:
                agrupador[i] = getattr(getattr(wizard_brw, i),'id')
            else:
                agrupador[i] =  getattr(wizard_brw, i)  
        
        if not agrupador['is_periodo']:
            fecha_desde_date = datetime.datetime.strptime(agrupador['fecha_desde'], "%Y-%m-%d")
            fecha_hasta_date = datetime.datetime.strptime(agrupador['fecha_hasta'], "%Y-%m-%d")
            dif = fecha_desde_date - fecha_hasta_date
            dif = abs(dif)
            if dif.days > 31:
                raise osv.except_osv('ERROR', "Las fechas no pueden exceder de 31 dias") 
        
        
        agrupador['periodo_name'] =  wizard_brw.period_id.name
        agrupador['location_name'] =  wizard_brw.location_id.name
        agrupador['product_name'] =  wizard_brw.product_id.name
        datas = {'form':agrupador}
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'analisis.inventario',
            'datas': datas,
       }
    
   
  
        
wizard_analisis_inventario()
