# /usr/bin/env python
# -*- encoding: utf-8 -*-

from osv import osv
from osv import fields

class wizard_cartera_cliente(osv.osv_memory):
    
    _name = "wizard.cartera.cliente"
    _description = "wizard para generar reporte de listado de clientes"
    _columns = {
    
    'vendedor_id': fields.many2one('res.users', 'Vendedor'),                         
    'equipo_ventas_id': fields.many2one('crm.case.section', 'Equipo de Ventas'), 
    'tipo': fields.boolean('Publica'),                        
    'asignado': fields.boolean('Sin Asignar'),                        
    'limite_credito': fields.boolean('Incluir limite de credito'),                           
    'formato':fields.selection([('Detallado','Detallado'),('Resumido', 'Resumido')], 'Formato', required=True),                  
                   
                }
    
    def generate_report(self, cr, uid, ids, context=None):
        self.cr = cr
        self.ids = ids
        create_brw = self.browse(cr, uid, ids)[0]
        vendedor_id = create_brw.vendedor_id.id
        equipo_ventas_id = create_brw.equipo_ventas_id.id
        asignado = create_brw.asignado
        limite_credito = create_brw.limite_credito
        tipo = create_brw.tipo
        formato = create_brw.formato
    
        clientes = self.crear_query(vendedor_id,equipo_ventas_id, tipo, asignado, limite_credito)
        cliente=[]
        
        if not asignado:
            for i in clientes:
                cliente.append(i[0])
        else:
            for i in clientes:
                if not tipo:
                    q = "select id from res_partner where customer = True and id = " + str(i[0])
                else:
                    q = "select id from res_partner where customer = True and id = " + str(i[0]) + " and public_partner = True"
                if vendedor_id:
                    q += " and user_id = " + str(vendedor_id)
                if equipo_ventas_id:
                    q += " and section_id = " + str(equipo_ventas_id)
                    
                cr.execute(q)
                res = cr.fetchall()
                if res:
                    cliente.append(res[0][0])
                
        titulo = self.titulo_filtros(vendedor_id, equipo_ventas_id, tipo, limite_credito, asignado)
        data={}
        if cliente:
            data['form'] = cliente
            data['tipo'] = formato
            data['limite'] = limite_credito
            data['filtro'] = titulo + ", " + formato
        else:
            raise osv.except_osv(('ERROR!'), ('La combinación para generar dicho reporte no arrojo ningún resultado!!!'))
        
        return {
            'type': 'ir.actions.report.xml',
            'report_name': 'cartera.cliente.xml',
            'datas': data,
       }
       
       
        
    def titulo_filtros(self,vendedor_id, equipo_ventas_id, tipo, limite_credito, asignado):
        titulo = ""
        if vendedor_id:
                query_v = """select name from res_users where id = %s order by id"""
                self.cr.execute(query_v %vendedor_id)
                vendedor = self.cr.fetchall()
                if titulo == "":
                    titulo += "Vendedor: " + str(vendedor[0][0])
                else:
                    titulo +=  ", vendedor: " + str(vendedor[0][0])
        else:
                if titulo == "":
                    titulo += "Vendedor: Todos"
                else:
                    titulo +=  ", vendedor: Todos"
                    
        if equipo_ventas_id: 
            query_equipo = """select complete_name from crm_case_section where id = %s order by id """
            self.cr.execute(query_equipo %equipo_ventas_id)
            equipo = self.cr.fetchall()
            if titulo == "":
                titulo += "Equipo de ventas: " + str(equipo[0][0])
            else:
                titulo +=  ", Equipo de ventas: " + str(equipo[0][0])
        else:
            if titulo == "":
                titulo += "Equipo de ventas: Todos"
            else:
                titulo +=  ", Equipo de ventas: Todos"
    
        if asignado:
            if titulo == "":
                titulo += "Sin asignar"
            else:
                titulo += ", Sin asignar"      
       
        if tipo == True:
            if titulo == "":
                titulo += "Red publica"
            else:
                titulo += ", Red publica"                   

        if limite_credito:                        
            if titulo == "":
                    titulo += "Limite Credito"
            else:
                    titulo += ", Limite Credito"    
        return titulo
    
  
    
    def crear_query(self, vendedor_id, equipo_ventas_id, tipo, asignado, limite_credito):
        string_query = ""
        lista=[]
        if vendedor_id:
            if string_query == "":
                string_query = "select id, name from res_partner where user_id = " + str(vendedor_id) 
            else:
                string_query += " and user_id = " + str(vendedor_id) 
        else:
            if asignado:
                if string_query == "":
                    string_query = "select id, name from res_partner where user_id is null" 
                else:
                    string_query += " or user_id is null" 
        
        if equipo_ventas_id:
            if string_query == "":
                string_query = "select id, name from res_partner where section_id = " + str(equipo_ventas_id) 
            else:
                string_query += " and section_id = " + str(equipo_ventas_id) 
        else:
            if asignado:
                if string_query == "":
                    string_query = "select id, name from res_partner where section_id is null" 
                else:
                    string_query += " or section_id is null" 
        if tipo:
            if string_query == "":
                string_query = "select id, name from res_partner where public_partner = True" 
            else:
                string_query += " and public_partner = True" 
                
        if string_query == "":
            string_query = "select id, name from res_partner where customer = True ORDER BY  name asc"
        else:
            string_query += " and customer = True ORDER BY name asc"
            
        self.cr.execute(string_query)
        res = self.cr.fetchall()

        return res
        
wizard_cartera_cliente()
