#-*- coding:utf-8 -*-
##############################################################################
#
#    SISB, Sistema Integral Simón Bolivar
#    Copyright (C) 2012-2013 Industrias Diana, C.A. All Rights Reserved
#
#    This program is free software: you can redistribute it and/or modify
#    it under the terms of the GNU Affero General Public License as published by
#    the Free Software Foundation, either version 3 of the License, or
#    (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU Affero General Public License for more details.
#
#    You should have received a copy of the GNU Affero General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.
#
##############################################################################

import pooler
import wizard

class wizard_sisb_reposos_medicos_conceptos_variables_historico_view(wizard.interface):
    
    def _get_reposo_continuo_ids(self, cr, uid, reposo_medico_id, context=None):
        """
        Retorna una lista con los ids de los reposos de toda la cadena de reposos continuos
        """
        reposos = pooler.get_pool(cr.dbname).get('sisb.reposos.medicos')
        reposo_medico_ids = []
        has_parent = True
        reposo = reposos.browse(cr, uid, reposo_medico_id, context=None)
        while has_parent:
            if reposo.parent_id:
                reposo = reposo.parent_id
                reposo_medico_ids.insert(0, reposo.id)
            else:
                has_parent = False
                 
        return reposo_medico_ids

    def _open_window(self, cr, uid, data, context={}):
        """
        Vista para 'sisb.reposos.medicos.conceptos.variables.historico' en la cual se muestran
        todos los conceptos cargados para un reposo y, en caso de existir, de 
        su cadena de reposos continuos.
        """
        if not context:
            context = {}
            
        reposo_medico_id = context.get('active_id')
        model_obj = pooler.get_pool(cr.dbname).get('ir.model.data')
        action_obj = pooler.get_pool(cr.dbname).get('ir.actions.act_window')
        historico = pooler.get_pool(cr.dbname).get('sisb.reposos.medicos.conceptos.variables.historico')
        reposos = pooler.get_pool(cr.dbname).get('sisb.reposos.medicos')

        reposo_medico_ids = self._get_reposo_continuo_ids(cr, uid, reposo_medico_id, context)
        reposo_medico_ids.append(reposo_medico_id)
        
        historico_ids = historico.search(cr, uid, [('reposo_medico_id','in',reposo_medico_ids)], context=None)
        result = model_obj._get_id(cr, uid, 'sisb_reposos_medicos', 'action_reposos_medicos_conceptos_variables_historico')
        id = model_obj.read(cr, uid, [result], ['res_id'])[0]['res_id']
        result = action_obj.read(cr, uid, [id])[0]
        
        result['domain'] = [('id','in',historico_ids)]
        return result
    
    states = {
        'init': {
            'actions': [],
            'result': {'type': 'action', 'action': _open_window, 'state': 'end'}
        }
    }
wizard_sisb_reposos_medicos_conceptos_variables_historico_view('wizard.sisb.reposos.medicos.conceptos.variables.historico.view')
