#!/usr/bin/python
# -*- encoding: utf-8 -*-

###############Credits########################################################
#    Developed by: Industrias Diana, C.A.
##############################################################################

import time
from report import report_sxw
from osv import osv
import pooler
from datetime import datetime, timedelta
import datetime as dt


class trans_interna(report_sxw.rml_parse):
    def __init__(self, cr, uid, name, context):
        super(trans_interna, self).__init__(cr, uid, name, context)
        self.localcontext.update({
            'time': time,
            'user': self.pool.get('res.users').browse(cr, uid, uid, context),
            'get_empresa': self.get_empresa,
            'get_final_date': self.get_final_date,
            'get_fecha': self.get_fecha,
            'get_hour_date': self.get_hour_date,
            'total': self.total,
            'traductor': self.traductor,
        })
        
    def get_empresa(self, partner_id):
        obj_addr = self.pool.get('res.partner.address')
        addr_id =obj_addr.search(self.cr, self.uid, [('type','=','invoice'),('partner_id','=',partner_id)])
        res = {}
        for row in obj_addr.browse(self.cr, self.uid, addr_id):
            res = {
            'street':row.street,
            'phone':row.phone,
            'fax':row.fax,
            'email':row.email,
            'city':row.city,
            'name':row.name,
            'country':row.country_id.name,
            } 
        return res
        
    
    def traductor(self, palabra):
        if palabra == "done":
            palabra = "Realizado"
        if palabra == "draft":
            palabra = "Borrador"
        if palabra == "confirm":
            palabra = "Confirmada"
            
        return palabra
    
    def total(self, l):
        suma = 0
        for i in l:
            suma = suma + i.amount
        return suma
        
    def get_hour_date(self):
        current_dt = datetime.now()
        a = ['AM','PM'][current_dt.hour>=12]
        return datetime.now().strftime('%H:%M:%S') + " " + a 
        
    def get_final_date(self):
        return datetime.now().strftime('%d-%m-%Y')
    
    def get_fecha(self, date):
        if str(date) == '':
            return False
        new = datetime.strptime(date, '%Y-%m-%d')
        return str(new.strftime('%d-%m-%Y'))
       
report_sxw.report_sxw('report.trans.interna.banca',
    'account.transf.int',
    'sisb_transf_int/report/trans_int_banc.rml',
    parser=trans_interna)
